"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const lodash_1 = require("lodash");
const Avatar_1 = require("@strapi/design-system/Avatar");
const utils_1 = require("../../utils");
const AdminAvatar_1 = __importDefault(require("../AdminAvatar"));
const UserAvatar = ({ avatar, name, isAdminComment = false, }) => {
    if (avatar) {
        let image = avatar;
        if ((0, lodash_1.isObject)(avatar)) {
            image = avatar?.formats?.thumbnail.url || avatar.url;
        }
        return isAdminComment ? (react_1.default.createElement(AdminAvatar_1.default, null, image ? react_1.default.createElement(Avatar_1.Avatar, { src: image, alt: name }) : null)) : image ? (react_1.default.createElement(Avatar_1.Avatar, { src: image, alt: name })) : null;
    }
    return isAdminComment ? (react_1.default.createElement(AdminAvatar_1.default, null, name ? react_1.default.createElement(Avatar_1.Initials, null, (0, utils_1.renderInitials)(name)) : null)) : name ? (react_1.default.createElement(Avatar_1.Initials, null, (0, utils_1.renderInitials)(name))) : null;
};
exports.default = UserAvatar;
//# sourceMappingURL=index.js.map