"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Box_1 = require("@strapi/design-system/Box");
const Flex_1 = require("@strapi/design-system/Flex");
const Typography_1 = require("@strapi/design-system/Typography");
const react_1 = __importStar(require("react"));
const DiscussionThreadItemActions_1 = __importDefault(require("../DiscussionThreadItemActions"));
const DiscussionThreadItemFooter_1 = __importDefault(require("../DiscussionThreadItemFooter"));
const styles_1 = require("./styles");
const satinizeHtml_1 = __importDefault(require("./../PreviewWysiwyg/utils/satinizeHtml"));
const mdRenderer_1 = __importDefault(require("./../PreviewWysiwyg/utils/mdRenderer"));
const DiscussionThreadItem = (props) => {
    const { as = "li", authorAvatar, authorName, content, isSelected, pinned, preview, root, } = props;
    const sanitizedContent = (0, react_1.useMemo)(() => (0, satinizeHtml_1.default)(mdRenderer_1.default.render(content || '')), [content]);
    return (react_1.default.createElement(styles_1.DiscussionThreadFullsize, { as: as, marginBottom: preview ? 4 : 0 },
        react_1.default.createElement(styles_1.DiscussionThreadItemContainer, { as: Flex_1.Flex, direction: "column", alignItems: "flex-start", hasRadius: true, background: isSelected ? "neutral100" : null, paddingLeft: 2, paddingRight: 2, paddingTop: 4, paddingBottom: 4 },
            react_1.default.createElement(styles_1.DiscussionThreadItemContent, { as: Flex_1.Flex, paddingBottom: 2, direction: "row" },
                react_1.default.createElement(Box_1.Box, { as: Flex_1.Flex, grow: 1, alignItems: "center", marginTop: "6px" },
                    react_1.default.createElement(Typography_1.Typography, { variant: "omega", textColor: "neutral800" },
                        react_1.default.createElement(styles_1.DiscussionThreadItemContentTypographyRenderer, { dangerouslySetInnerHTML: { __html: sanitizedContent } }))),
                !preview && (react_1.default.createElement(DiscussionThreadItemActions_1.default, { ...props, root: root || pinned, preview: preview }))),
            react_1.default.createElement(DiscussionThreadItemFooter_1.default, { ...props }))));
};
exports.default = DiscussionThreadItem;
//# sourceMappingURL=index.js.map