"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const prop_types_1 = __importDefault(require("prop-types"));
const react_query_1 = require("react-query");
const react_router_dom_1 = require("react-router-dom");
const lodash_1 = require("lodash");
const Flex_1 = require("@strapi/design-system/Flex");
const IconButton_1 = require("@strapi/design-system/IconButton");
const icons_1 = require("../../components/icons");
const helper_plugin_1 = require("@strapi/helper-plugin");
const utils_1 = require("../../utils");
const styles_1 = require("./styles");
const ConfirmationDialog_1 = __importDefault(require("../ConfirmationDialog"));
const api_1 = require("../../pages/utils/api");
const pluginId_1 = require("../../pluginId");
const icons_2 = require("../icons");
const DiscussionThreadItemApprovalFlowActions_1 = __importDefault(require("../DiscussionThreadItemApprovalFlowActions"));
const StatusBadge_1 = __importDefault(require("../StatusBadge"));
const styles_2 = require("../IconButton/styles");
const styles_3 = require("../ActionButton/styles");
const DiscussionThreadItemReviewAction_1 = __importDefault(require("../DiscussionThreadItemReviewAction"));
const ModeratorResponseModal_1 = __importDefault(require("../ModeratorResponseModal/ModeratorResponseModal"));
const DiscussionThreadItemActions = ({ allowedActions: { canModerate, canAccessReports, canReviewReports }, ...item }) => {
    const { id, blocked, removed, content, blockedThread, gotThread, threadFirstItemId, pinned, preview, reports = [], approvalStatus, author, isAdminComment, } = item;
    const user = helper_plugin_1.auth.get('userInfo');
    const [blockConfirmationVisible, setBlockConfirmationVisible] = (0, react_1.useState)(false);
    const [blockThreadConfirmationVisible, setBlockThreadConfirmationVisible] = (0, react_1.useState)(false);
    const [blockButtonsDisabled, setBlockButtonsDisabled] = (0, react_1.useState)(blockedThread);
    const [startThreadVisible, setStartThreadVisible] = (0, react_1.useState)(false);
    const [updateCommentVisible, setUpdateCommentVisible] = (0, react_1.useState)(false);
    const { push } = (0, react_router_dom_1.useHistory)();
    const toggleNotification = (0, helper_plugin_1.useNotification)();
    const queryClient = (0, react_query_1.useQueryClient)();
    const { lockApp, unlockApp } = (0, helper_plugin_1.useOverlayBlocker)();
    const onSuccess = (message, sideEffectCallback) => () => {
        queryClient.invalidateQueries("get-details-data");
        if (message) {
            toggleNotification({
                type: "success",
                message: `${pluginId_1.pluginId}.${message}`,
            });
        }
        sideEffectCallback();
        unlockApp();
    };
    const onError = (err) => {
        (0, utils_1.handleAPIError)(err, toggleNotification);
    };
    const mutationConfig = (message = "", sideEffectCallback = lodash_1.noop) => {
        return {
            onSuccess: onSuccess(message, sideEffectCallback),
            onError
        };
    };
    const resolveAllAbuseReportsForThreadMutation = (0, react_query_1.useMutation)(api_1.resolveAllAbuseReportsForThread, mutationConfig());
    const blockItemMutation = (0, react_query_1.useMutation)(api_1.blockItem, mutationConfig("page.details.actions.comment.block.confirmation.success", setBlockConfirmationVisible));
    const unblockItemMutation = (0, react_query_1.useMutation)(api_1.unblockItem, mutationConfig("page.details.actions.comment.unblock.confirmation.success"));
    const blockItemThreadMutation = (0, react_query_1.useMutation)(api_1.blockItemThread, mutationConfig("page.details.actions.thread.block.confirmation.success", setBlockThreadConfirmationVisible));
    const unblockItemThreadMutation = (0, react_query_1.useMutation)(api_1.unblockItemThread, mutationConfig("page.details.actions.thread.unblock.confirmation.success"));
    const deleteItemMutation = (0, react_query_1.useMutation)(api_1.deleteItem, mutationConfig("page.details.actions.comment.delete.confirmation.success"));
    const isAdminAuthor = String(user?.id) === author?.id;
    const gotApprovalFlow = !(0, lodash_1.isNil)(approvalStatus);
    const needsApproval = !isAdminComment && gotApprovalFlow && approvalStatus === "PENDING";
    const isBlocked = blocked || blockedThread;
    const isRejected = gotApprovalFlow && approvalStatus === "REJECTED";
    const openReports = reports?.filter((_) => !_.resolved);
    const hasReports = !(0, lodash_1.isEmpty)(openReports);
    const reviewFlowEnabled = (canAccessReports || canReviewReports) && hasReports;
    const hasActiveThread = gotThread && !(removed || preview || pinned || blockedThread);
    const isStatusBadgeVisible = isBlocked || reviewFlowEnabled;
    const renderStatus = (props) => {
        const status = (0, utils_1.resolveCommentStatus)({ ...props, reviewFlowEnabled });
        const color = (0, utils_1.resolveCommentStatusColor)(status);
        return (react_1.default.createElement(StatusBadge_1.default, { backgroundColor: `${color}100`, textColor: `${color}700`, color: color }, (0, utils_1.getMessage)({
            id: `page.common.item.status.${status}`,
            props: {
                count: openReports.length,
            },
        }, status)));
    };
    const isLoading = unblockItemMutation.isLoading ||
        blockItemMutation.isLoading ||
        blockItemThreadMutation.isLoading ||
        unblockItemThreadMutation.isLoading;
    const handleResolveAllAbuseReportsForThread = () => {
        if (canModerate) {
            lockApp();
            resolveAllAbuseReportsForThreadMutation.mutate(id);
        }
    };
    const handleBlockClick = () => setBlockConfirmationVisible(true);
    const handleBlockConfirm = () => {
        if (canModerate) {
            lockApp();
            blockItemMutation.mutate(id);
        }
    };
    const handleBlockCancel = () => {
        setBlockConfirmationVisible(false);
    };
    const handleUnblockClick = () => {
        if (canModerate) {
            lockApp();
            unblockItemMutation.mutate(id);
        }
    };
    const handleDeleteClick = () => {
        if (canModerate) {
            lockApp();
            deleteItemMutation.mutate(id);
        }
    };
    const handleBlockThreadClick = () => setBlockThreadConfirmationVisible(true);
    const handleBlockThreadConfirm = () => {
        if (canModerate) {
            lockApp();
            blockItemThreadMutation.mutate(id);
        }
    };
    const handleBlockThreadCancel = () => {
        setBlockThreadConfirmationVisible(false);
    };
    const toggleStartThreadVisibility = () => {
        setStartThreadVisible(!startThreadVisible);
    };
    const toggleUpdateCommentVisibility = () => {
        setUpdateCommentVisible(!updateCommentVisible);
    };
    const handleUnblockThreadClick = () => {
        if (canModerate) {
            lockApp();
            unblockItemThreadMutation.mutate(id);
        }
    };
    const handleDrilldownClick = () => {
        if (hasActiveThread) {
            push((0, utils_1.getUrl)(`discover/${threadFirstItemId}`));
        }
    };
    const handleOnConfirm = (0, react_1.useCallback)(() => {
        handleBlockThreadConfirm(id);
        handleResolveAllAbuseReportsForThread(id);
    }, [handleBlockThreadConfirm, handleResolveAllAbuseReportsForThread]);
    const anyGroupButtonsVisible = needsApproval || reviewFlowEnabled || !blockedThread;
    if (removed || isRejected || !canModerate) {
        return (react_1.default.createElement(styles_1.DiscussionThreadItemActionsWrapper, { as: Flex_1.Flex, direction: "row" }, renderStatus(item)));
    }
    const isBlockEnabled = !blockedThread && !(blocked || needsApproval);
    const isUnblockEnabled = !blockedThread && blocked;
    const isRemovable = !blockedThread && !blocked && isAdminAuthor;
    const isThreadStartEnabled = !hasActiveThread && !pinned && (!blockedThread && !blocked);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(styles_1.DiscussionThreadItemActionsWrapper, { as: Flex_1.Flex, direction: "row" },
            isStatusBadgeVisible && renderStatus(item),
            !blockedThread && (gotThread || pinned) && (react_1.default.createElement(styles_3.ActionButton, { onClick: handleBlockThreadClick, startIcon: icons_2.lock, loading: blockItemThreadMutation.isLoading, variant: "danger" }, (0, utils_1.getMessage)("page.details.actions.thread.block", "Block thread"))),
            blockedThread && (gotThread || pinned) && (react_1.default.createElement(styles_3.ActionButton, { onClick: handleUnblockThreadClick, startIcon: icons_2.unlock, loading: unblockItemThreadMutation.isLoading, variant: "success" }, (0, utils_1.getMessage)("page.details.actions.thread.unblock", "Unblock thread"))),
            anyGroupButtonsVisible && (react_1.default.createElement(styles_2.IconButtonGroupStyled, { isSingle: true, withMargin: true },
                !isAdminComment && (react_1.default.createElement(react_1.default.Fragment, null,
                    isBlockEnabled && (react_1.default.createElement(IconButton_1.IconButton, { onClick: handleBlockClick, loading: blockItemMutation.isLoading, icon: icons_2.lock, label: (0, utils_1.getMessage)("page.details.actions.comment.block", "Block") })),
                    isUnblockEnabled && (react_1.default.createElement(IconButton_1.IconButton, { onClick: handleUnblockClick, loading: unblockItemMutation.isLoading, icon: icons_2.unlock, label: (0, utils_1.getMessage)("page.details.actions.comment.unblock", "Unblock") })))),
                needsApproval && (react_1.default.createElement(DiscussionThreadItemApprovalFlowActions_1.default, { id: id, allowedActions: { canModerate }, queryToInvalidate: "get-details-data" })),
                isAdminAuthor && !isBlocked && (react_1.default.createElement(IconButton_1.IconButton, { onClick: toggleUpdateCommentVisibility, icon: icons_1.pencil, label: (0, utils_1.getMessage)("page.details.actions.thread.modal.update.comment") })),
                isRemovable && (react_1.default.createElement(IconButton_1.IconButton, { onClick: handleDeleteClick, loading: deleteItemMutation.isLoading, icon: icons_1.trash, label: (0, utils_1.getMessage)("page.details.actions.comment.delete", "Delete comment") })),
                react_1.default.createElement(DiscussionThreadItemReviewAction_1.default, { item: item, queryToInvalidate: "get-details-data", allowedActions: {
                        canModerate,
                        canAccessReports,
                        canReviewReports,
                    }, isAnyActionLoading: isLoading }))),
            hasActiveThread && (react_1.default.createElement(styles_2.IconButtonGroupStyled, { isSingle: true, withMargin: true },
                react_1.default.createElement(IconButton_1.IconButton, { onClick: handleDrilldownClick, icon: icons_2.eye, label: (0, utils_1.getMessage)("page.details.panel.discussion.nav.drilldown", "Drilldown thread"), style: blocked && !blockedThread
                        ? { marginTop: "1px", marginRight: ".5rem" }
                        : {} }))),
            isThreadStartEnabled && (react_1.default.createElement(styles_2.IconButtonGroupStyled, { isSingle: true, withMargin: true },
                react_1.default.createElement(IconButton_1.IconButton, { onClick: toggleStartThreadVisibility, icon: icons_1.plus, label: (0, utils_1.getMessage)("page.details.actions.thread.modal.start.thread") })))),
        startThreadVisible &&
            react_1.default.createElement(ModeratorResponseModal_1.default, { content: "", id: id, title: (0, utils_1.getMessage)("page.details.actions.thread.modal.start.thread"), onClose: toggleStartThreadVisibility }),
        updateCommentVisible &&
            react_1.default.createElement(ModeratorResponseModal_1.default, { content: content, id: id, title: (0, utils_1.getMessage)("page.details.actions.thread.modal.update.comment"), onClose: toggleUpdateCommentVisibility }),
        !blocked && (react_1.default.createElement(ConfirmationDialog_1.default, { isVisible: blockConfirmationVisible, isActionAsync: blockItemMutation.isLoading, header: (0, utils_1.getMessage)("page.details.actions.comment.block.confirmation.header"), labelConfirm: (0, utils_1.getMessage)("page.details.actions.comment.block.confirmation.button.confirm"), iconConfirm: icons_2.lock, onConfirm: handleBlockConfirm, onCancel: handleBlockCancel }, (0, utils_1.getMessage)("page.details.actions.comment.block.confirmation.description"))),
        !blockedThread && (react_1.default.createElement(ConfirmationDialog_1.default, { isVisible: blockThreadConfirmationVisible, isActionAsync: blockItemThreadMutation.isLoading, header: (0, utils_1.getMessage)("page.details.actions.thread.block.confirmation.header"), labelConfirm: (0, utils_1.getMessage)("page.details.actions.thread.block.confirmation.button.confirm"), iconConfirm: icons_2.lock, onConfirm: handleOnConfirm, onCancel: handleBlockThreadCancel }, (0, utils_1.getMessage)("page.details.actions.thread.block.confirmation.description")))));
};
DiscussionThreadItemActions.propTypes = {
    isRoot: prop_types_1.default.bool,
    blocked: prop_types_1.default.bool.isRequired,
    blockedThread: prop_types_1.default.bool.isRequired,
    approvalStatus: prop_types_1.default.oneOfType([
        prop_types_1.default.nullable,
        prop_types_1.default.oneOf(["PENDING", "APPROVED", "REJECTED"]),
    ]),
    allowedActions: prop_types_1.default.shape({
        canModerate: prop_types_1.default.bool,
    }),
};
exports.default = DiscussionThreadItemActions;
//# sourceMappingURL=index.js.map