"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const prop_types_1 = __importDefault(require("prop-types"));
const react_intl_1 = require("react-intl");
const Box_1 = require("@strapi/design-system/Box");
const Typography_1 = require("@strapi/design-system/Typography");
const styles_1 = require("./styles");
const Avatar_1 = __importDefault(require("../Avatar"));
const utils_1 = require("../../utils");
const DiscussionThreadItemFooter = ({ author, isAdminComment, children, createdAt, updatedAt, }) => {
    const { formatDate } = (0, react_intl_1.useIntl)();
    const dateTime = formatDate(updatedAt || createdAt, {
        dateStyle: "medium",
        timeStyle: "short",
    });
    const { name, avatar } = author || {};
    return (react_1.default.createElement(styles_1.DiscussionThreadItemFooterStyled, { as: Box_1.Box, paddingTop: 2, direction: "row" },
        react_1.default.createElement(styles_1.DiscussionThreadItemFooterMeta, { size: 3, horizontal: true },
            author && react_1.default.createElement(Avatar_1.default, { avatar: avatar, name: name, isAdminComment: isAdminComment }),
            react_1.default.createElement(Typography_1.Typography, { variant: "pi", fontWeight: "bold", textColor: "neutral800" }, name || (0, utils_1.getMessage)("compontents.author.unknown")),
            react_1.default.createElement(Typography_1.Typography, { variant: "pi", textColor: "neutral600" }, dateTime)),
        children));
};
DiscussionThreadItemFooter.propTypes = {
    author: prop_types_1.default.shape({
        id: prop_types_1.default.oneOfType(prop_types_1.default.string, prop_types_1.default.number).isRequired,
        name: prop_types_1.default.string.isRequired,
        email: prop_types_1.default.string,
        avatar: prop_types_1.default.oneOfType(prop_types_1.default.string, prop_types_1.default.object),
    }).isRequired,
    createdAt: prop_types_1.default.string.isRequired,
    updatedAt: prop_types_1.default.string,
    children: prop_types_1.default.array,
};
exports.default = DiscussionThreadItemFooter;
//# sourceMappingURL=index.js.map