"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Hint = void 0;
const react_1 = __importDefault(require("react"));
const react_intl_1 = require("react-intl");
const Typography_1 = require("@strapi/design-system/Typography");
const Hint = ({ id, error, name, description }) => {
    const { formatMessage } = (0, react_intl_1.useIntl)();
    const hint = description
        ? formatMessage({ id: description.id, defaultMessage: description.defaultMessage }, { ...description.values })
        : '';
    if (!hint || error) {
        return null;
    }
    return (react_1.default.createElement(Typography_1.Typography, { as: "p", variant: "pi", id: `${id || name}-hint`, textColor: "neutral600" }, hint));
};
exports.Hint = Hint;
exports.default = exports.Hint;
//# sourceMappingURL=index.js.map