"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_query_1 = require("react-query");
const api_1 = require("../../pages/utils/api");
const styles_1 = require("./styles");
const api_2 = require("../../pages/utils/api");
const Box_1 = require("@strapi/design-system/Box");
const Typography_1 = require("@strapi/design-system/Typography");
const Flex_1 = require("@strapi/design-system/Flex");
const Button_1 = require("@strapi/design-system/Button");
const Divider_1 = require("@strapi/design-system/Divider");
const utils_1 = require("../../utils");
const Wysiwyg_1 = __importDefault(require("../Wysiwyg"));
const helper_plugin_1 = require("@strapi/helper-plugin");
const pluginId_1 = require("../../pluginId");
const ModeratorResponse = ({ rootThread, }) => {
    const { id: threadId, blockedThread } = rootThread;
    const [commentField, setCommentField] = (0, react_1.useState)("");
    const [isFieldEmpty, setIsFieldEmpty] = (0, react_1.useState)(true);
    const handleCommentChange = (e) => {
        setCommentField(e.target.value);
    };
    const user = helper_plugin_1.auth.get("userInfo");
    (0, react_1.useEffect)(() => {
        setIsFieldEmpty(!commentField);
    }, [commentField]);
    const toggleNotification = (0, helper_plugin_1.useNotification)();
    const queryClient = (0, react_query_1.useQueryClient)();
    const { lockApp, unlockApp } = (0, helper_plugin_1.useOverlayBlocker)();
    const onSuccess = (message, stateAction = (_func) => { }) => async () => {
        await queryClient.invalidateQueries("get-details-data");
        toggleNotification({
            type: "success",
            message: `${pluginId_1.pluginId}.${message}`,
        });
        stateAction(false);
        setCommentField('');
        unlockApp();
    };
    const onError = (err) => {
        (0, utils_1.handleAPIError)(err, toggleNotification);
    };
    const unblockItemThreadMutation = (0, react_query_1.useMutation)(api_1.unblockItemThread);
    const postCommentMutation = (0, react_query_1.useMutation)(api_2.postComment, {
        onSuccess: onSuccess("page.details.actions.comment.post.confirmation"),
        onError,
    });
    const handleSave = async () => {
        lockApp();
        await postCommentMutation.mutate({
            threadId,
            body: commentField,
            author: user,
        });
    };
    const handleReopen = async () => {
        lockApp();
        await unblockItemThreadMutation.mutate(threadId);
        await postCommentMutation.mutate({
            threadId,
            body: commentField,
            author: user,
        });
    };
    const intlLabel = {
        id: "",
        defaultMessage: "",
        values: {},
    };
    return (react_1.default.createElement(styles_1.ModeratorResponseStyled, null,
        react_1.default.createElement(Divider_1.Divider, null),
        react_1.default.createElement(Box_1.Box, { hasRadius: true, padding: 4 },
            react_1.default.createElement(Box_1.Box, null,
                react_1.default.createElement(Typography_1.Typography, { variant: "delta", textColor: "neutral800", id: "moderator-reply" }, (0, utils_1.getMessage)("page.details.panel.discussion.reply", "Reply"))),
            react_1.default.createElement(Box_1.Box, { paddingTop: 2, paddingBottom: 4 },
                react_1.default.createElement(Wysiwyg_1.default, { name: "", value: commentField, onChange: handleCommentChange, intlLabel: intlLabel })),
            react_1.default.createElement(Flex_1.Flex, { direction: "row", justifyContent: "flex-end", gap: 2 },
                blockedThread && (react_1.default.createElement(Button_1.Button, { variant: "secondary", onClick: handleReopen, disabled: isFieldEmpty }, (0, utils_1.getMessage)("page.details.panel.discussion.reopen", "Re-open"))),
                react_1.default.createElement(Button_1.Button, { variant: "primary", onClick: handleSave, disabled: isFieldEmpty }, (0, utils_1.getMessage)("page.details.panel.discussion.send", "Send"))))));
};
exports.default = ModeratorResponse;
//# sourceMappingURL=index.js.map