"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_query_1 = require("react-query");
const api_1 = require("../../pages/utils/api");
const ModalLayout_1 = require("@strapi/design-system/ModalLayout");
const Typography_1 = require("@strapi/design-system/Typography");
const Button_1 = require("@strapi/design-system/Button");
const utils_1 = require("../../utils");
const Wysiwyg_1 = __importDefault(require("../Wysiwyg"));
const helper_plugin_1 = require("@strapi/helper-plugin");
const pluginId_1 = require("../../pluginId");
const ModeratorResponseModal = ({ content, id, title, onClose, }) => {
    const [commentField, setCommentField] = (0, react_1.useState)(content);
    const handleCommentChange = (e) => {
        setCommentField(e.target.value);
    };
    const user = helper_plugin_1.auth.get("userInfo");
    const handleClose = onClose;
    const toggleNotification = (0, helper_plugin_1.useNotification)();
    const queryClient = (0, react_query_1.useQueryClient)();
    const { lockApp, unlockApp } = (0, helper_plugin_1.useOverlayBlocker)();
    const onSuccess = (message, stateAction = (_func) => { }) => async () => {
        await queryClient.invalidateQueries("get-details-data");
        onClose();
        toggleNotification({
            type: "success",
            message: `${pluginId_1.pluginId}.${message}`,
        });
        stateAction(false);
        unlockApp();
    };
    const onError = (err) => {
        (0, utils_1.handleAPIError)(err, toggleNotification);
    };
    const postCommentMutation = (0, react_query_1.useMutation)(api_1.postComment, {
        onSuccess: onSuccess("page.details.actions.comment.post.confirmation"),
        onError,
    });
    const updateCommentMutation = (0, react_query_1.useMutation)(api_1.updateComment, {
        onSuccess: onSuccess("page.details.actions.comment.update.confirmation"),
        onError,
    });
    const handlePostComment = async () => {
        lockApp();
        await postCommentMutation.mutate({
            threadId: id,
            body: commentField,
            author: user,
        });
    };
    const handleUpdateComment = async () => {
        lockApp();
        await updateCommentMutation.mutate({
            id,
            body: commentField,
        });
    };
    const intlLabel = {
        id: "",
        defaultMessage: "",
        values: {},
    };
    return (react_1.default.createElement(ModalLayout_1.ModalLayout, { onClose: handleClose, labelledBy: title },
        react_1.default.createElement(ModalLayout_1.ModalHeader, null,
            react_1.default.createElement(Typography_1.Typography, { fontWeight: "bold", textColor: "neutral800", as: "h2", id: "title" }, title)),
        react_1.default.createElement(ModalLayout_1.ModalBody, null,
            react_1.default.createElement(Wysiwyg_1.default, { name: "", value: commentField, onChange: handleCommentChange, intlLabel: intlLabel })),
        react_1.default.createElement(ModalLayout_1.ModalFooter, { startActions: react_1.default.createElement(Button_1.Button, { onClick: handleClose, variant: "tertiary" }, (0, utils_1.getMessage)("compontents.confirmation.dialog.button.cancel")), endActions: content.length ? (react_1.default.createElement(Button_1.Button, { onClick: handleUpdateComment }, (0, utils_1.getMessage)("page.details.actions.thread.modal.update.comment"))) : (react_1.default.createElement(Button_1.Button, { onClick: handlePostComment }, (0, utils_1.getMessage)("page.details.actions.thread.modal.start.thread"))) })));
};
exports.default = ModeratorResponseModal;
//# sourceMappingURL=ModeratorResponseModal.js.map