"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const SubNav_1 = require("@strapi/design-system/SubNav");
const icons_1 = require("../icons");
const getMessage_1 = __importDefault(require("../../utils/getMessage"));
const getUrl_1 = __importDefault(require("../../utils/getUrl"));
const Nav = ({ visible = false, hasNewComments, hasNewReports }) => {
    if (!visible) {
        return null;
    }
    return (react_1.default.createElement(SubNav_1.SubNav, { ariaLabel: 'Comments sub nav' },
        react_1.default.createElement(SubNav_1.SubNavHeader, { label: (0, getMessage_1.default)('plugin.name') }),
        react_1.default.createElement(SubNav_1.SubNavSections, null,
            react_1.default.createElement(SubNav_1.SubNavSection, { label: (0, getMessage_1.default)('nav.header.moderation') },
                react_1.default.createElement(SubNav_1.SubNavLink, { to: (0, getUrl_1.default)('discover'), icon: icons_1.discuss }, (0, getMessage_1.default)('nav.item.discover')),
                react_1.default.createElement(SubNav_1.SubNavLink, { to: (0, getUrl_1.default)('reports'), withBullet: hasNewReports, icon: icons_1.thumbDown }, (0, getMessage_1.default)('nav.item.reports'))))));
};
exports.default = Nav;
//# sourceMappingURL=index.js.map