"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const markdown_it_1 = __importDefault(require("markdown-it"));
const highlight_js_1 = require("highlight.js");
const markdown_it_abbr_1 = __importDefault(require("markdown-it-abbr"));
const markdown_it_container_1 = __importDefault(require("markdown-it-container"));
const markdown_it_deflist_1 = __importDefault(require("markdown-it-deflist"));
const markdown_it_emoji_1 = __importDefault(require("markdown-it-emoji"));
const markdown_it_footnote_1 = __importDefault(require("markdown-it-footnote"));
const markdown_it_ins_1 = __importDefault(require("markdown-it-ins"));
const markdown_it_mark_1 = __importDefault(require("markdown-it-mark"));
const markdown_it_sub_1 = __importDefault(require("markdown-it-sub"));
const markdown_it_sup_1 = __importDefault(require("markdown-it-sup"));
const loadCss = async () => {
    await Promise.resolve().then(() => __importStar(require('highlight.js/styles/solarized-dark.css')));
};
loadCss();
const md = new markdown_it_1.default({
    html: true,
    xhtmlOut: false,
    breaks: true,
    langPrefix: 'language-',
    linkify: true,
    typographer: true,
    highlight: (str, lang) => {
        if (lang && lang !== 'auto' && (0, highlight_js_1.getLanguage)(lang)) {
            return ('<pre class="hljs language-' +
                md.utils.escapeHtml(lang.toLowerCase()) +
                '"><code>' +
                (0, highlight_js_1.highlight)(lang, str, true).value +
                '</code></pre>');
        }
        if (lang === 'auto') {
            const result = (0, highlight_js_1.highlightAuto)(str);
            return ('<pre class="hljs language-' +
                md.utils.escapeHtml(result.language) +
                '"><code>' +
                result.value +
                '</code></pre>');
        }
        return '<pre class="hljs"><code>' + md.utils.escapeHtml(str) + '</code></pre>';
    },
})
    .use(markdown_it_abbr_1.default)
    .use(markdown_it_container_1.default, 'warning')
    .use(markdown_it_container_1.default, 'tip')
    .use(markdown_it_deflist_1.default)
    .use(markdown_it_emoji_1.default)
    .use(markdown_it_footnote_1.default)
    .use(markdown_it_ins_1.default)
    .use(markdown_it_mark_1.default)
    .use(markdown_it_sub_1.default)
    .use(markdown_it_sup_1.default);
md.renderer.rules.footnote_ref = (tokens, idx, options, env, slf) => {
    const caption = slf.rules.footnote_caption(tokens, idx, options, env, slf);
    return '<sup class="footnote-ref"><span>' + caption + '</span></sup>';
};
md.renderer.rules.footnote_anchor = () => {
    return ' <span class="footnote-backref">\u21a9\uFE0E</span>';
};
exports.default = md;
//# sourceMappingURL=mdRenderer.js.map