"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const SimpleMenu_1 = require("@strapi/design-system/SimpleMenu");
const utils_1 = require("../../../../utils");
const iconButtonStyle = { minHeight: "2em", paddingLeft: '5px', paddingRight: "12px" };
const BlockMenu = ({ handlers: { handleBlockItemClick, handleBlockItemThreadClick, handleClickResolve, handleResolveAllAbuseReportsForComment, handleResolveAllAbuseReportsForThread, handleUnblockItemClick, handleUnblockThreadClick, }, item, type, }) => {
    const { id: reportId, related: { blocked: blockedComment, blockedThread, gotThread, id: commentId } } = item;
    const isIconButton = type === "icon";
    const handleBlockComment = (0, react_1.useCallback)(() => {
        handleBlockItemClick(commentId);
        handleResolveAllAbuseReportsForComment(commentId);
    }, [handleBlockItemClick, handleResolveAllAbuseReportsForComment]);
    const handleUnblockComment = (0, react_1.useCallback)(() => handleUnblockItemClick(commentId), [handleUnblockItemClick]);
    const handleBlockThread = (0, react_1.useCallback)(() => {
        handleBlockItemThreadClick(commentId);
        handleResolveAllAbuseReportsForThread(commentId);
    }, [handleBlockItemThreadClick, handleResolveAllAbuseReportsForThread]);
    const handleUnblockThread = (0, react_1.useCallback)(() => {
        handleUnblockThreadClick(commentId);
    }, [handleUnblockThreadClick]);
    return (react_1.default.createElement(SimpleMenu_1.SimpleMenu, { label: isIconButton ? null : "Block", variant: "danger-light", style: isIconButton ? iconButtonStyle : null },
        !blockedComment ? (react_1.default.createElement(SimpleMenu_1.MenuItem, { disabled: blockedThread, onClick: handleBlockComment }, (0, utils_1.getMessage)("page.details.actions.comment.block", "Block comment"))) : (react_1.default.createElement(SimpleMenu_1.MenuItem, { disabled: blockedThread, onClick: handleUnblockComment }, (0, utils_1.getMessage)("page.details.actions.comment.unblock", "Unblock comment"))),
        gotThread &&
            (!blockedThread ? (react_1.default.createElement(SimpleMenu_1.MenuItem, { onClick: handleBlockThread }, (0, utils_1.getMessage)("page.details.actions.thread.block", "Block thread"))) : (react_1.default.createElement(SimpleMenu_1.MenuItem, { onClick: handleUnblockThread }, (0, utils_1.getMessage)("page.details.actions.thread.unblock", "Unblock thread"))))));
};
exports.default = BlockMenu;
//# sourceMappingURL=index.js.map