"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const styles_1 = require("../ActionButton/styles");
const Flex_1 = require("@strapi/design-system/Flex");
const icons_1 = require("../icons");
const utils_1 = require("../../utils");
const useReportsActionsHandlers_1 = __importDefault(require("../../hooks/useReportsActionsHandlers"));
const BlockMenu_1 = __importDefault(require("./components/BlockMenu"));
const ReportsActions = ({ allowedActions, item, mutation, onSelectionChange, reports, selectedReports, updateReports, }) => {
    const { id: reportId, resolved, related: { blocked: blockedComment, blockedThread, gotThread, id: commentId } } = item;
    const handlers = (0, useReportsActionsHandlers_1.default)({
        allowedActions,
        commentId,
        mutation,
        onSelectionChange,
        reports,
        selectedReports,
        updateReports
    });
    const { handleClickResolve } = handlers;
    return (react_1.default.createElement(Flex_1.Flex, null,
        !resolved ? (react_1.default.createElement(styles_1.ActionButton, { isSingle: true, onClick: () => handleClickResolve(reportId), startIcon: icons_1.check, variant: "success" }, (0, utils_1.getMessage)("page.details.panel.discussion.warnings.reports.dialog.actions.resolve", "resolve"))) : (react_1.default.createElement(BlockMenu_1.default, { handlers: handlers, item: item })),
        !resolved &&
            react_1.default.createElement(BlockMenu_1.default, { handlers: handlers, item: item, type: "icon" })));
};
exports.default = ReportsActions;
//# sourceMappingURL=index.js.map