"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const prop_types_1 = __importDefault(require("prop-types"));
const ModalLayout_1 = require("@strapi/design-system/ModalLayout");
const Typography_1 = require("@strapi/design-system/Typography");
const utils_1 = require("../../utils");
const DiscussionThreadItem_1 = __importDefault(require("../DiscussionThreadItem"));
const ReportsReviewModal = ({ isVisible = false, item, children, onClose, startActions, endActions, }) => isVisible && (react_1.default.createElement(ModalLayout_1.ModalLayout, { onClose: onClose },
    react_1.default.createElement(ModalLayout_1.ModalHeader, null,
        react_1.default.createElement(Typography_1.Typography, { fontWeight: "bold", textColor: "neutral800", as: "h2", id: "title" }, (0, utils_1.getMessage)("page.details.panel.discussion.warnings.reports.dialog.header", "Open reports"))),
    react_1.default.createElement(ModalLayout_1.ModalBody, null,
        react_1.default.createElement(DiscussionThreadItem_1.default, { as: "div", ...item, root: true, preview: true, isSelected: true }),
        children),
    react_1.default.createElement(ModalLayout_1.ModalFooter, { variant: "tertiary", startActions: startActions, endActions: endActions })));
ReportsReviewModal.propTypes = {
    isVisible: prop_types_1.default.bool,
    startActions: prop_types_1.default.array,
    endActions: prop_types_1.default.array,
    item: prop_types_1.default.object.isRequired,
    children: prop_types_1.default.array.isRequired,
    allowedActions: prop_types_1.default.shape({
        canModerate: prop_types_1.default.bool,
        canAccessReports: prop_types_1.default.bool,
        canReviewReports: prop_types_1.default.bool,
    }),
    onClose: prop_types_1.default.func.isRequired,
};
exports.default = ReportsReviewModal;
//# sourceMappingURL=index.js.map