"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const prop_types_1 = __importDefault(require("prop-types"));
const Box_1 = require("@strapi/design-system/Box");
const Flex_1 = require("@strapi/design-system/Flex");
const helper_plugin_1 = require("@strapi/helper-plugin");
const TablePagination = ({ pagination }) => {
    return (react_1.default.createElement(Box_1.Box, { paddingTop: 4 },
        react_1.default.createElement(Flex_1.Flex, { alignItems: "flex-end", justifyContent: "space-between" },
            react_1.default.createElement(helper_plugin_1.PageSizeURLQuery, { trackedEvent: "willChangeNumberOfEntriesPerPage" }),
            react_1.default.createElement(helper_plugin_1.PaginationURLQuery, { pagination: pagination }))));
};
TablePagination.defaultProps = {
    pagination: {
        pageCount: 0,
        pageSize: 10,
        total: 0,
    },
};
TablePagination.propTypes = {
    pagination: prop_types_1.default.shape({
        page: prop_types_1.default.number,
        pageCount: prop_types_1.default.number,
        pageSize: prop_types_1.default.number,
        total: prop_types_1.default.number,
    }),
};
exports.default = TablePagination;
//# sourceMappingURL=index.js.map