"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const lodash_1 = require("lodash");
const codemirror5_1 = __importDefault(require("codemirror5"));
require("codemirror5/addon/display/placeholder");
const PreviewWysiwyg_1 = __importDefault(require("../PreviewWysiwyg"));
const EditorStylesContainer_1 = require("./EditorStylesContainer");
const WysiwygStyles_1 = require("./WysiwygStyles");
const continueList_1 = __importDefault(require("./utils/continueList"));
const Editor = ({ disabled, editorRef, error, isPreviewMode, isExpandMode, name, onChange, placeholder, textareaRef, value, }) => {
    const onChangeRef = (0, react_1.useRef)(onChange);
    (0, react_1.useEffect)(() => {
        editorRef.current = codemirror5_1.default.fromTextArea(textareaRef.current, {
            lineWrapping: true,
            extraKeys: {
                Enter: 'newlineAndIndentContinueMarkdownList',
                Tab: false,
                'Shift-Tab': false,
            },
            readOnly: false,
            smartIndent: false,
            placeholder,
            spellcheck: true,
            inputStyle: 'contenteditable',
        });
        codemirror5_1.default.commands.newlineAndIndentContinueMarkdownList = continueList_1.default;
        editorRef.current.on('change', doc => {
            onChangeRef.current({ target: { name, value: doc.getValue(), type: 'wysiwyg' } });
        });
    }, [editorRef, textareaRef, name, placeholder]);
    (0, react_1.useEffect)(() => {
        if ((0, lodash_1.isString)(value) && !editorRef.current.state.focused) {
            editorRef.current.setValue(value);
        }
    }, [editorRef, value]);
    (0, react_1.useEffect)(() => {
        if (isPreviewMode || disabled) {
            editorRef.current.setOption('readOnly', 'nocursor');
        }
        else {
            editorRef.current.setOption('readOnly', false);
        }
    }, [disabled, isPreviewMode, editorRef]);
    (0, react_1.useEffect)(() => {
        if (error) {
            editorRef.current.setOption('screenReaderLabel', error);
        }
        else {
            editorRef.current.setOption('screenReaderLabel', 'Editor');
        }
    }, [editorRef, error]);
    return (react_1.default.createElement(WysiwygStyles_1.EditorAndPreviewWrapper, null,
        react_1.default.createElement(EditorStylesContainer_1.EditorStylesContainer, { isExpandMode: isExpandMode, disabled: disabled || isPreviewMode },
            react_1.default.createElement("textarea", { ref: textareaRef })),
        isPreviewMode && react_1.default.createElement(PreviewWysiwyg_1.default, { data: value })));
};
exports.default = Editor;
//# sourceMappingURL=Editor.js.map