"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EditorLayout = exports.ExpandButton = void 0;
const react_1 = __importStar(require("react"));
const styled_components_1 = __importDefault(require("styled-components"));
const Flex_1 = require("@strapi/design-system/Flex");
const Box_1 = require("@strapi/design-system/Box");
const FocusTrap_1 = require("@strapi/design-system/FocusTrap");
const Portal_1 = require("@strapi/design-system/Portal");
const BaseButton_1 = require("@strapi/design-system/BaseButton");
const Typography_1 = require("@strapi/design-system/Typography");
const helper_plugin_1 = require("@strapi/helper-plugin");
const Collapse_1 = __importDefault(require("@strapi/icons/Collapse"));
const react_intl_1 = require("react-intl");
const PreviewWysiwyg_1 = __importDefault(require("../PreviewWysiwyg"));
const setOpacity = (hex, alpha) => `${hex}${Math.floor(alpha * 255)
    .toString(16)
    .padStart(2, 0)}`;
const ExpandWrapper = (0, styled_components_1.default)(Flex_1.Flex) `
  background: ${({ theme }) => setOpacity(theme.colors.neutral800, 0.2)};
`;
const BoxWithBorder = (0, styled_components_1.default)(Box_1.Box) `
  border-right: 1px solid ${({ theme }) => theme.colors.neutral200};
`;
exports.ExpandButton = (0, styled_components_1.default)(BaseButton_1.BaseButton) `
  background-color: transparent;
  border: none;
  align-items: center;

  svg {
    margin-left: ${({ theme }) => `${theme.spaces[2]}`};
    path {
      fill: ${({ theme }) => theme.colors.neutral700};
      width: ${12 / 16}rem;
      height: ${12 / 16}rem;
    }
  }
`;
const EditorLayout = ({ children, isExpandMode, error, previewContent, onCollapse }) => {
    const { formatMessage } = (0, react_intl_1.useIntl)();
    (0, react_1.useEffect)(() => {
        const body = document.body;
        if (isExpandMode) {
            body.classList.add('lock-body-scroll');
        }
        return () => {
            if (isExpandMode) {
                body.classList.remove('lock-body-scroll');
            }
        };
    }, [isExpandMode]);
    if (isExpandMode) {
        return (react_1.default.createElement(Portal_1.Portal, { role: "dialog", "aria-modal": false },
            react_1.default.createElement(FocusTrap_1.FocusTrap, { onEscape: onCollapse },
                react_1.default.createElement(ExpandWrapper, { position: "fixed", top: 0, left: 0, right: 0, bottom: 0, zIndex: 4, justifyContent: "center", onClick: onCollapse },
                    react_1.default.createElement(Box_1.Box, { id: "wysiwyg-expand", background: "neutral0", hasRadius: true, shadow: "popupShadow", overflow: "hidden", width: "70%", height: "70%", onClick: (e) => e.stopPropagation() },
                        react_1.default.createElement(Flex_1.Flex, { height: "100%", alignItems: "flex-start" },
                            react_1.default.createElement(BoxWithBorder, { flex: "1", height: "100%" }, children),
                            react_1.default.createElement(Box_1.Box, { flex: "1", height: "100%" },
                                react_1.default.createElement(Flex_1.Flex, { height: (0, helper_plugin_1.pxToRem)(48), background: "neutral100", justifyContent: "flex-end" },
                                    react_1.default.createElement(exports.ExpandButton, { id: "collapse", onClick: onCollapse },
                                        react_1.default.createElement(Typography_1.Typography, null, formatMessage({
                                            id: 'components.Wysiwyg.collapse',
                                            defaultMessage: 'Collapse',
                                        })),
                                        react_1.default.createElement(Collapse_1.default, null))),
                                react_1.default.createElement(Box_1.Box, { position: "relative", height: "100%" },
                                    react_1.default.createElement(PreviewWysiwyg_1.default, { data: previewContent })))))))));
    }
    return (react_1.default.createElement(Box_1.Box, { borderColor: error ? 'danger600' : 'neutral200', borderStyle: "solid", borderWidth: "1px", hasRadius: true }, children));
};
exports.EditorLayout = EditorLayout;
//# sourceMappingURL=EditorLayout.js.map