"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_intl_1 = require("react-intl");
const Box_1 = require("@strapi/design-system/Box");
const Flex_1 = require("@strapi/design-system/Flex");
const Typography_1 = require("@strapi/design-system/Typography");
const Expand_1 = __importDefault(require("@strapi/icons/Expand"));
const WysiwygStyles_1 = require("./WysiwygStyles");
const WysiwygFooter = ({ onToggleExpand }) => {
    const { formatMessage } = (0, react_intl_1.useIntl)();
    return (react_1.default.createElement(Box_1.Box, { padding: 2, background: "neutral100", hasRadius: true },
        react_1.default.createElement(Flex_1.Flex, { justifyContent: "flex-end", alignItems: "flex-end" },
            react_1.default.createElement(WysiwygStyles_1.ExpandButton, { id: "expand", onClick: onToggleExpand },
                react_1.default.createElement(Typography_1.Typography, null, formatMessage({
                    id: 'components.WysiwygBottomControls.fullscreen',
                    defaultMessage: 'Expand',
                })),
                react_1.default.createElement(Expand_1.default, null)))));
};
exports.default = WysiwygFooter;
//# sourceMappingURL=WysiwygFooter.js.map