"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_intl_1 = require("react-intl");
const FocusTrap_1 = require("@strapi/design-system/FocusTrap");
const Box_1 = require("@strapi/design-system/Box");
const Button_1 = require("@strapi/design-system/Button");
const IconButton_1 = require("@strapi/design-system/IconButton");
const Popover_1 = require("@strapi/design-system/Popover");
const Flex_1 = require("@strapi/design-system/Flex");
const Bold_1 = __importDefault(require("@strapi/icons/Bold"));
const Italic_1 = __importDefault(require("@strapi/icons/Italic"));
const Underline_1 = __importDefault(require("@strapi/icons/Underline"));
const StrikeThrough_1 = __importDefault(require("@strapi/icons/StrikeThrough"));
const BulletList_1 = __importDefault(require("@strapi/icons/BulletList"));
const NumberList_1 = __importDefault(require("@strapi/icons/NumberList"));
const Code_1 = __importDefault(require("@strapi/icons/Code"));
const Picture_1 = __importDefault(require("@strapi/icons/Picture"));
const Link_1 = __importDefault(require("@strapi/icons/Link"));
const Quote_1 = __importDefault(require("@strapi/icons/Quote"));
const WysiwygStyles_1 = require("./WysiwygStyles");
const WysiwygNav = ({ disabled, editorRef, isExpandMode, isPreviewMode, onActionClick, onToggleMediaLib, onTogglePreviewMode, }) => {
    const [visiblePopover, setVisiblePopover] = (0, react_1.useState)(false);
    const { formatMessage } = (0, react_intl_1.useIntl)();
    const buttonMoreRef = (0, react_1.useRef)();
    const handleTogglePopover = () => {
        setVisiblePopover(prev => !prev);
    };
    if (disabled || isPreviewMode) {
        return (react_1.default.createElement(Box_1.Box, { padding: 2, background: "neutral100" },
            react_1.default.createElement(Flex_1.Flex, { justifyContent: "space-between" },
                react_1.default.createElement(Flex_1.Flex, null,
                    react_1.default.createElement(WysiwygStyles_1.MainButtons, null,
                        react_1.default.createElement(WysiwygStyles_1.CustomIconButton, { disabled: true, id: "Bold", label: "Bold", name: "Bold", icon: react_1.default.createElement(Bold_1.default, null) }),
                        react_1.default.createElement(WysiwygStyles_1.CustomIconButton, { disabled: true, id: "Italic", label: "Italic", name: "Italic", icon: react_1.default.createElement(Italic_1.default, null) }),
                        react_1.default.createElement(WysiwygStyles_1.CustomIconButton, { disabled: true, id: "Underline", label: "Underline", name: "Underline", icon: react_1.default.createElement(Underline_1.default, null) }))),
                !isExpandMode && (react_1.default.createElement(Button_1.Button, { onClick: onTogglePreviewMode, variant: "tertiary", id: "preview" }, formatMessage({
                    id: 'components.Wysiwyg.ToggleMode.markdown-mode',
                    defaultMessage: 'Markdown mode',
                }))))));
    }
    return (react_1.default.createElement(Box_1.Box, { padding: 2, background: "neutral100" },
        react_1.default.createElement(Flex_1.Flex, { justifyContent: "space-between" },
            react_1.default.createElement(Flex_1.Flex, null,
                react_1.default.createElement(WysiwygStyles_1.MainButtons, null,
                    react_1.default.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => onActionClick('Bold', editorRef), id: "Bold", label: "Bold", name: "Bold", icon: react_1.default.createElement(Bold_1.default, null) }),
                    react_1.default.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => onActionClick('Italic', editorRef), id: "Italic", label: "Italic", name: "Italic", icon: react_1.default.createElement(Italic_1.default, null) }),
                    react_1.default.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => onActionClick('Underline', editorRef), id: "Underline", label: "Underline", name: "Underline", icon: react_1.default.createElement(Underline_1.default, null) })),
                visiblePopover && (react_1.default.createElement(Popover_1.Popover, { centered: true, source: buttonMoreRef, spacing: 4, id: "popover" },
                    react_1.default.createElement(FocusTrap_1.FocusTrap, { onEscape: handleTogglePopover, restoreFocus: false },
                        react_1.default.createElement(Flex_1.Flex, null,
                            react_1.default.createElement(WysiwygStyles_1.IconButtonGroupMargin, null,
                                react_1.default.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => onActionClick('Strikethrough', editorRef, handleTogglePopover), id: "Strikethrough", label: "Strikethrough", name: "Strikethrough", icon: react_1.default.createElement(StrikeThrough_1.default, null) }),
                                react_1.default.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => onActionClick('BulletList', editorRef, handleTogglePopover), id: "BulletList", label: "BulletList", name: "BulletList", icon: react_1.default.createElement(BulletList_1.default, null) }),
                                react_1.default.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => onActionClick('NumberList', editorRef, handleTogglePopover), id: "NumberList", label: "NumberList", name: "NumberList", icon: react_1.default.createElement(NumberList_1.default, null) })),
                            react_1.default.createElement(IconButton_1.IconButtonGroup, null,
                                react_1.default.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => onActionClick('Code', editorRef, handleTogglePopover), id: "Code", label: "Code", name: "Code", icon: react_1.default.createElement(Code_1.default, null) }),
                                react_1.default.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => {
                                        handleTogglePopover();
                                        onToggleMediaLib();
                                    }, id: "Image", label: "Image", name: "Image", icon: react_1.default.createElement(Picture_1.default, null) }),
                                react_1.default.createElement(WysiwygStyles_1.CustomLinkIconButton, { onClick: () => onActionClick('Link', editorRef, handleTogglePopover), id: "Link", label: "Link", name: "Link", icon: react_1.default.createElement(Link_1.default, null) }),
                                react_1.default.createElement(WysiwygStyles_1.CustomIconButton, { onClick: () => onActionClick('Quote', editorRef, handleTogglePopover), id: "Quote", label: "Quote", name: "Quote", icon: react_1.default.createElement(Quote_1.default, null) }))))))),
            onTogglePreviewMode && (react_1.default.createElement(Button_1.Button, { onClick: onTogglePreviewMode, variant: "tertiary", id: "preview" }, formatMessage({
                id: 'components.Wysiwyg.ToggleMode.preview-mode',
                defaultMessage: 'Preview mode',
            }))))));
};
exports.default = WysiwygNav;
//# sourceMappingURL=WysiwygNav.js.map