"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExpandButton = exports.EditorAndPreviewWrapper = exports.IconButtonGroupMargin = exports.MoreButton = exports.MainButtons = exports.CustomLinkIconButton = exports.CustomIconButton = void 0;
const styled_components_1 = __importDefault(require("styled-components"));
const IconButton_1 = require("@strapi/design-system/IconButton");
const BaseButton_1 = require("@strapi/design-system/BaseButton");
exports.CustomIconButton = (0, styled_components_1.default)(IconButton_1.IconButton) `
  padding: ${({ theme }) => theme.spaces[2]};
  /* Trick to prevent the outline from overflowing because of the general outline-offset */
  outline-offset: -2px !important;

  svg {
    width: ${18 / 16}rem;
    height: ${18 / 16}rem;
  }
`;
exports.CustomLinkIconButton = (0, styled_components_1.default)(exports.CustomIconButton) `
  svg {
    width: ${8 / 16}rem;
    height: ${8 / 16}rem;
  }
`;
exports.MainButtons = (0, styled_components_1.default)(IconButton_1.IconButtonGroup) `
  
`;
exports.MoreButton = (0, styled_components_1.default)(IconButton_1.IconButton) `
  margin: ${({ theme }) => `0 ${theme.spaces[2]}`};
  padding: ${({ theme }) => theme.spaces[2]};

  svg {
    width: ${18 / 16}rem;
    height: ${18 / 16}rem;
  }
`;
exports.IconButtonGroupMargin = (0, styled_components_1.default)(IconButton_1.IconButtonGroup) `
  margin-right: ${({ theme }) => `${theme.spaces[2]}`};
`;
exports.EditorAndPreviewWrapper = styled_components_1.default.div `
  position: relative;
  height: calc(100% - 48px);
`;
exports.ExpandButton = (0, styled_components_1.default)(BaseButton_1.BaseButton) `
  background-color: transparent;
  border: none;
  align-items: center;

  svg {
    margin-left: ${({ theme }) => `${theme.spaces[2]}`};
    path {
      fill: ${({ theme }) => theme.colors.neutral700};
      width: ${12 / 16}rem;
      height: ${12 / 16}rem;
    }
  }
`;
//# sourceMappingURL=WysiwygStyles.js.map