"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomFieldInput = void 0;
const react_1 = __importStar(require("react"));
const Stack_1 = require("@strapi/design-system/Stack");
const Flex_1 = require("@strapi/design-system/Flex");
const Box_1 = require("@strapi/design-system/Box");
const Field_1 = require("@strapi/design-system/Field");
const Select_1 = require("@strapi/design-system/Select");
const NumberInput_1 = require("@strapi/design-system/NumberInput");
const Checkbox_1 = require("@strapi/design-system/Checkbox");
const DatePicker_1 = require("@strapi/design-system/DatePicker");
const Grid_1 = require("@strapi/design-system/Grid");
const utils_1 = require("./utils");
const utils_2 = require("../../../../utils");
const react_intl_1 = require("react-intl");
const consts_1 = require("./consts");
const CustomFieldInput = ({ attribute, description, disabled, error, intlLabel, labelAction, name, onChange, required, value, }) => {
    const { formatMessage } = (0, react_intl_1.useIntl)();
    const [currentState, setCurrentState] = (0, react_1.useState)(value ? (0, utils_1.fromInput)(value) : consts_1.DEFAULTS);
    const onCommentsNumberChange = (0, react_1.useCallback)((0, utils_1.handleStateSliceChange)("commentsNumber", setCurrentState), [setCurrentState]);
    const onRenderTypeChange = (0, react_1.useCallback)((0, utils_1.handleStateSliceChange)("renderType", setCurrentState), [setCurrentState]);
    const onSortByDateChange = (0, react_1.useCallback)((0, utils_1.handleStateSliceChange)("sortByDate", setCurrentState), [setCurrentState]);
    const onFilterByChange = (0, react_1.useCallback)((filterBy) => {
        setCurrentState((current) => ({
            ...current,
            filterBy,
            filterByValue: undefined,
        }));
    }, [setCurrentState]);
    const onFilterByValueChange = (0, react_1.useCallback)((0, utils_1.handleStateSliceChange)("filterByValue", setCurrentState), [setCurrentState]);
    const onPopulateAuthorChange = (0, react_1.useCallback)((0, utils_1.handlePopulateChange)("author", setCurrentState), [setCurrentState]);
    const onPopulateAvatarChange = (0, react_1.useCallback)((0, utils_1.handlePopulateChange)("avatar", setCurrentState), [setCurrentState]);
    (0, react_1.useEffect)(() => {
        const nextValue = (0, utils_1.toOutput)(currentState);
        const initialValue = value ? (0, utils_1.toOutput)((0, utils_1.fromInput)(value)) : "";
        if (initialValue !== nextValue && onChange) {
            onChange({
                target: {
                    name,
                    value: nextValue,
                    type: attribute.type,
                },
            });
        }
    }, [currentState, value]);
    return (react_1.default.createElement(Field_1.Field, { name: name, id: name, error: error, hint: description && (0, utils_2.getMessage)(description) },
        react_1.default.createElement(Stack_1.Stack, { spacing: 1 },
            react_1.default.createElement(Flex_1.Flex, null,
                react_1.default.createElement(Field_1.FieldLabel, { required: required }, formatMessage(intlLabel)),
                labelAction && react_1.default.createElement(Box_1.Box, { paddingLeft: 1 }, labelAction)),
            react_1.default.createElement(Grid_1.Grid, { gap: 4 },
                react_1.default.createElement(Grid_1.GridItem, { col: 6 },
                    react_1.default.createElement(Box_1.Box, { paddingTop: 2 },
                        react_1.default.createElement(NumberInput_1.NumberInput, { disabled: disabled, label: (0, utils_2.getMessage)("customField.comments.input.commentsNumber.label", "Number of comments"), name: `${name}.commentsNumber`, value: currentState.commentsNumber, onValueChange: onCommentsNumberChange })),
                    react_1.default.createElement(Box_1.Box, { paddingTop: 2 },
                        react_1.default.createElement(Select_1.Select, { disabled: disabled, name: `${name}.renderType`, label: (0, utils_2.getMessage)("customField.comments.input.renderType.label", "Render comments as"), value: currentState.renderType, onChange: onRenderTypeChange }, (0, utils_1.getRenderTypeOptions)(utils_2.getMessage).map(({ value, label }) => (react_1.default.createElement(Select_1.Option, { key: `renderTypeOptions-${value}`, value: value }, label))))),
                    react_1.default.createElement(Box_1.Box, { paddingTop: 2 },
                        react_1.default.createElement(Select_1.Select, { disabled: disabled, name: `${name}.sortByDate`, label: (0, utils_2.getMessage)("customField.comments.input.sortByDate.label", "Sort by creation date"), value: currentState.sortByDate, onChange: onSortByDateChange, onClear: () => onSortByDateChange(undefined) }, (0, utils_1.getSortByDateOptions)(utils_2.getMessage).map(({ value, label }) => (react_1.default.createElement(Select_1.Option, { key: `sortByDataOptions-${value}`, value: value }, label)))))),
                react_1.default.createElement(Grid_1.GridItem, { col: 6 },
                    react_1.default.createElement(Box_1.Box, { paddingTop: 2 },
                        react_1.default.createElement(Select_1.Select, { disabled: disabled, name: `${name}.filterBy`, label: (0, utils_2.getMessage)("customField.comments.input.filterBy.label", "Filter by"), value: currentState.filterBy, onChange: onFilterByChange, onClear: () => onFilterByChange(undefined) }, (0, utils_1.getFilterByOptions)(utils_2.getMessage).map(({ value, label }) => (react_1.default.createElement(Select_1.Option, { key: `filterByOptions-${value}`, value: value }, label)))),
                        react_1.default.createElement(Box_1.Box, { paddingTop: currentState.filterBy ? 2 : 0 },
                            currentState.filterBy === "APPROVAL_STATUS" ? (react_1.default.createElement(Select_1.Select, { label: (0, utils_2.getMessage)("customField.comments.input.filterBy.option.approvalStatus.label.details.label", "Specify date"), disabled: disabled, name: `${name}.filterBy.approvalStatus`, value: currentState.filterByValue, onChange: onFilterByValueChange, onClear: () => onFilterByValueChange(undefined) }, (0, utils_1.getApprovalStatusOptions)(utils_2.getMessage).map(({ value, label }) => (react_1.default.createElement(Select_1.Option, { key: `approvalStatusOptions-${value}`, value: value }, label))))) : null,
                            currentState.filterBy === "DATE_CREATED" ? (react_1.default.createElement(DatePicker_1.DatePicker, { label: (0, utils_2.getMessage)("customField.comments.input.filterBy.option.dateCreated.label.details.label", "Specify date"), disabled: disabled, name: `${name}.filterBy.dateCreated`, onChange: onFilterByValueChange, onClear: () => onFilterByValueChange(undefined), selectedDate: currentState.filterByValue, selectedDateLabel: utils_1.asString })) : null)),
                    react_1.default.createElement(Box_1.Box, { paddingTop: 2 },
                        react_1.default.createElement(Field_1.FieldLabel, null, (0, utils_2.getMessage)("customField.comments.input.populate.label", "Populate")),
                        react_1.default.createElement(Box_1.Box, { paddingTop: 1 },
                            react_1.default.createElement(Checkbox_1.Checkbox, { disabled: disabled, children: (0, utils_2.getMessage)("customField.comments.input.populate.author.label", "Populate author field"), value: currentState.populate?.includes("author"), name: `${name}.populate.author`, onChange: onPopulateAuthorChange }),
                            react_1.default.createElement(Checkbox_1.Checkbox, { disabled: disabled, children: (0, utils_2.getMessage)("customField.comments.input.populate.avatar.label", "Populate avatar field"), value: currentState.populate?.includes("avatar"), name: `${name}.populate.avatar`, onChange: onPopulateAvatarChange }))))),
            react_1.default.createElement(Field_1.FieldHint, null),
            react_1.default.createElement(Field_1.FieldError, null))));
};
exports.CustomFieldInput = CustomFieldInput;
//# sourceMappingURL=input.js.map