"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const helper_plugin_1 = require("@strapi/helper-plugin");
const lodash_1 = require("lodash");
const pluginPkg = __importStar(require("../../package.json"));
const pluginId_1 = require("./pluginId");
const Initializer_1 = __importDefault(require("./components/Initializer"));
const PluginIcon_1 = __importDefault(require("./components/PluginIcon"));
const permissions_1 = __importDefault(require("./permissions"));
const reducers_1 = __importDefault(require("./reducers"));
const custom_fields_1 = require("./custom-fields");
const translations_1 = __importDefault(require("./translations"));
const { name, displayName } = pluginPkg.strapi;
exports.default = {
    register(app) {
        app.addMenuLink({
            to: `/plugins/${pluginId_1.pluginId}`,
            badgeContent: 1,
            icon: PluginIcon_1.default,
            intlLabel: {
                id: `${pluginId_1.pluginId}.plugin.name`,
                defaultMessage: displayName,
            },
            Component: async () => {
                const component = await Promise.resolve().then(() => __importStar(require('./pages/App')));
                return component;
            },
            permissions: permissions_1.default.access,
        });
        app.createSettingSection({
            id: pluginId_1.pluginId,
            intlLabel: {
                id: `${pluginId_1.pluginId}.plugin.section`,
                defaultMessage: `${displayName} plugin`,
            },
        }, [
            {
                intlLabel: {
                    id: `${pluginId_1.pluginId}.plugin.section.item`,
                    defaultMessage: "Configuration",
                },
                id: "comments",
                to: `/settings/${pluginId_1.pluginId}`,
                Component: async () => {
                    const component = await Promise.resolve().then(() => __importStar(require("./pages/Settings")));
                    return component;
                },
                permissions: permissions_1.default.settings,
            },
        ]);
        app.addReducers(reducers_1.default);
        app.registerPlugin({
            id: pluginId_1.pluginId,
            initializer: Initializer_1.default,
            isReady: false,
            name,
        });
        (0, custom_fields_1.registerCustomFields)(app);
    },
    registerTrads({ locales = [] }) {
        return locales.map((locale) => {
            return {
                data: (0, helper_plugin_1.prefixPluginTranslations)((0, lodash_1.get)(translations_1.default, locale), pluginId_1.pluginId, {}),
                locale,
            };
        });
    },
};
//# sourceMappingURL=index.js.map