"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapDispatchToProps = void 0;
const react_1 = __importDefault(require("react"));
const react_redux_1 = require("react-redux");
const redux_1 = require("redux");
const react_router_dom_1 = require("react-router-dom");
const react_query_1 = require("react-query");
const helper_plugin_1 = require("@strapi/helper-plugin");
const ComingSoonPage_1 = __importDefault(require("../ComingSoonPage"));
const getUrl_1 = __importDefault(require("../../utils/getUrl"));
const Discover_1 = __importDefault(require("../Discover"));
const Details_1 = __importDefault(require("../Details"));
const Reports_1 = __importDefault(require("../Reports"));
const api_1 = require("./utils/api");
const actions_1 = require("./reducer/actions");
const selectors_1 = __importDefault(require("./reducer/selectors"));
const App = ({ setConfig }) => {
    const toggleNotification = (0, helper_plugin_1.useNotification)();
    const { isLoading, isFetching } = (0, react_query_1.useQuery)('get-config', () => (0, api_1.fetchConfig)(toggleNotification), {
        initialData: {},
        onSuccess: (response) => {
            setConfig(response);
        },
    });
    if (isLoading || isFetching) {
        return react_1.default.createElement(helper_plugin_1.LoadingIndicatorPage, null);
    }
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(react_router_dom_1.Switch, null,
            react_1.default.createElement(react_router_dom_1.Route, { path: (0, getUrl_1.default)('discover/:id'), component: Details_1.default }),
            react_1.default.createElement(react_router_dom_1.Route, { path: (0, getUrl_1.default)('dashboard'), component: ComingSoonPage_1.default }),
            react_1.default.createElement(react_router_dom_1.Route, { path: (0, getUrl_1.default)('discover'), component: Discover_1.default }),
            react_1.default.createElement(react_router_dom_1.Route, { path: (0, getUrl_1.default)('settings'), component: ComingSoonPage_1.default }),
            react_1.default.createElement(react_router_dom_1.Route, { path: (0, getUrl_1.default)('reports'), component: Reports_1.default }),
            react_1.default.createElement(react_router_dom_1.Route, { path: (0, getUrl_1.default)(), exact: true, children: react_1.default.createElement(react_router_dom_1.Redirect, { to: (0, getUrl_1.default)('discover') }) }))));
};
const mapStateToProps = (0, selectors_1.default)();
function mapDispatchToProps(dispatch) {
    return (0, redux_1.bindActionCreators)({ setConfig: actions_1.setConfig }, dispatch);
}
exports.mapDispatchToProps = mapDispatchToProps;
const withConnect = (0, react_redux_1.connect)(mapStateToProps, mapDispatchToProps);
exports.default = (0, redux_1.compose)(withConnect)(App);
//# sourceMappingURL=index.js.map