"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initialState = void 0;
const immer_1 = __importDefault(require("immer"));
const lodash_1 = require("lodash");
const constants_1 = require("./constants");
const initialState = {
    config: {},
};
exports.initialState = initialState;
const reducer = (state = initialState, action) => (0, immer_1.default)(state, (draftState) => {
    switch (action.type) {
        case constants_1.SET_CONFIG: {
            (0, lodash_1.set)(draftState, "config", action.data);
            break;
        }
        case constants_1.GET_CONFIG: {
            return draftState?.config;
        }
        default:
            return draftState;
    }
});
exports.default = reducer;
//# sourceMappingURL=index.js.map