"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const prop_types_1 = __importDefault(require("prop-types"));
const Box_1 = require("@strapi/design-system/Box");
const Flex_1 = require("@strapi/design-system/Flex");
const Stack_1 = require("@strapi/design-system/Stack");
const Checkbox_1 = require("@strapi/design-system/Checkbox");
const utils_1 = require("../../../../utils");
const DetailsFilters = ({ data, onChange }) => {
    const { removed = false } = data;
    const handleOnChange = (prop, value) => onChange({
        ...data,
        [prop]: !value ? undefined : value,
    });
    return (react_1.default.createElement(Box_1.Box, { as: Flex_1.Flex },
        react_1.default.createElement(Stack_1.Stack, { size: 2, vertical: true },
            react_1.default.createElement(Checkbox_1.Checkbox, { checked: removed, onChange: () => handleOnChange("removed", !removed), visibleLabels: true }, (0, utils_1.getMessage)("page.details.filters.removed.label", "Show removed comments")))));
};
DetailsFilters.propTypes = {
    data: prop_types_1.default.object.isRequired,
    onChange: prop_types_1.default.func.isRequired,
};
exports.default = DetailsFilters;
//# sourceMappingURL=index.js.map