"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapDispatchToProps = void 0;
const react_1 = __importStar(require("react"));
const react_redux_1 = require("react-redux");
const redux_1 = require("redux");
const react_fast_compare_1 = __importDefault(require("react-fast-compare"));
const react_query_1 = require("react-query");
const react_router_dom_1 = require("react-router-dom");
const Layout_1 = require("@strapi/design-system/Layout");
const Box_1 = require("@strapi/design-system/Box");
const Link_1 = require("@strapi/design-system/Link");
const LiveRegions_1 = require("@strapi/design-system/LiveRegions");
const icons_1 = require("../../components/icons");
const lodash_1 = require("lodash");
const helper_plugin_1 = require("@strapi/helper-plugin");
const getMessage_1 = __importDefault(require("../../utils/getMessage"));
const api_1 = require("../utils/api");
const permissions_1 = __importDefault(require("../../permissions"));
const utils_1 = require("../../utils");
const Nav_1 = __importDefault(require("../../components/Nav"));
const DetailsEntity_1 = __importDefault(require("./components/DetailsEntity"));
const DiscussionThread_1 = __importDefault(require("../../components/DiscussionThread"));
const selectors_1 = __importDefault(require("../App/reducer/selectors"));
const ModeratorResponse_1 = __importDefault(require("../../components/ModeratorResponse"));
const Details = ({ config }) => {
    (0, helper_plugin_1.useFocusWhenNavigate)();
    const { params: { id }, } = (0, react_router_dom_1.useRouteMatch)((0, utils_1.getUrl)(`discover/:id`));
    const { notifyStatus } = (0, LiveRegions_1.useNotifyAT)();
    const { trackUsage } = (0, helper_plugin_1.useTracking)();
    const trackUsageRef = (0, react_1.useRef)(trackUsage);
    const toggleNotification = (0, helper_plugin_1.useNotification)();
    const viewPermissions = (0, react_1.useMemo)(() => ({
        access: permissions_1.default.access,
        moderate: permissions_1.default.moderate,
        accessReports: permissions_1.default.reports,
        reviewReports: permissions_1.default.reportsReview,
    }), []);
    const { isLoading: isLoadingForPermissions, allowedActions: { canAccess, canModerate, canAccessReports, canReviewReports, }, } = (0, helper_plugin_1.useRBAC)(viewPermissions);
    const [filters, setFilters] = (0, react_1.useState)({});
    const regexUID = new RegExp((0, utils_1.parseRegExp)(config.regex.uid).value, (0, utils_1.parseRegExp)(config.regex.uid).flags);
    const { isLoading: isLoadingForData, data, isFetching, } = (0, react_query_1.useQuery)(["get-details-data", id, filters, canAccess], () => (0, api_1.fetchDetailsData)(id, filters, toggleNotification), {
        initialData: {},
    });
    const { entity, level, selected } = data;
    const entityUidValid = entity?.uid && regexUID.test(entity.uid);
    const { data: contentTypeData } = (0, react_query_1.useQuery)(["get-additional-data", entity?.uid, canAccess], () => (0, api_1.fetchContentTypeData)(entity?.uid, toggleNotification), {
        enabled: !!entity?.uid,
        suspense: !entityUidValid,
    });
    const handleChangeFilters = (props) => setFilters(props);
    const isLoading = isLoadingForData || isFetching;
    if (canAccess) {
        return (react_1.default.createElement(Box_1.Box, { background: "neutral100" },
            react_1.default.createElement(Layout_1.Layout, { sideNav: react_1.default.createElement(Nav_1.default, { visible: true }) }, (isLoading || isLoadingForPermissions) && (0, lodash_1.isEmpty)(data) ? (react_1.default.createElement(helper_plugin_1.LoadingIndicatorPage, null)) : (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement(Layout_1.HeaderLayout, { navigationAction: react_1.default.createElement(Link_1.Link, { startIcon: icons_1.arrowLeft, to: (0, utils_1.getUrl)(`discover`) }, (0, getMessage_1.default)("HeaderLayout.link.go-back", "Back", false)), title: (0, getMessage_1.default)("page.details.header"), subtitle: (0, getMessage_1.default)("page.details.header.description"), as: "h2" }),
                react_1.default.createElement(Layout_1.ContentLayout, null,
                    react_1.default.createElement(Layout_1.TwoColsLayout, { startCol: react_1.default.createElement(react_1.default.Fragment, null,
                            react_1.default.createElement(DiscussionThread_1.default, { level: level, selected: selected, isReloading: isLoading, allowedActions: {
                                    canModerate,
                                    canAccessReports,
                                    canReviewReports,
                                } }),
                            selected?.threadOf && (react_1.default.createElement(ModeratorResponse_1.default, { rootThread: { ...selected.threadOf } }))), endCol: react_1.default.createElement(DetailsEntity_1.default, { data: entity, schema: contentTypeData?.schema, config: config, filters: filters, onFiltersChange: handleChangeFilters }) })))))));
    }
    return null;
};
const mapStateToProps = (0, selectors_1.default)();
function mapDispatchToProps(dispatch) {
    return (0, redux_1.bindActionCreators)({}, dispatch);
}
exports.mapDispatchToProps = mapDispatchToProps;
const withConnect = (0, react_redux_1.connect)(mapStateToProps, mapDispatchToProps);
exports.default = (0, redux_1.compose)(withConnect)((0, react_1.memo)(Details, react_fast_compare_1.default));
//# sourceMappingURL=index.js.map