"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const prop_types_1 = __importDefault(require("prop-types"));
const react_intl_1 = require("react-intl");
const lodash_1 = require("lodash");
const Flex_1 = require("@strapi/design-system/Flex");
const IconButton_1 = require("@strapi/design-system/IconButton");
const Link_1 = require("@strapi/design-system/Link");
const Stack_1 = require("@strapi/design-system/Stack");
const Table_1 = require("@strapi/design-system/Table");
const Typography_1 = require("@strapi/design-system/Typography");
const utils_1 = require("../../../../utils");
const icons_1 = require("../../../../components/icons");
const styles_1 = require("./styles");
const renderEntryTitle_1 = __importDefault(require("../../../../utils/renderEntryTitle"));
const DiscussionThreadItemApprovalFlowActions_1 = __importDefault(require("../../../../components/DiscussionThreadItemApprovalFlowActions"));
const StatusBadge_1 = __importDefault(require("../../../../components/StatusBadge"));
const styles_2 = require("../../../../components/IconButton/styles");
const DiscussionThreadItemReviewAction_1 = __importDefault(require("../../../../components/DiscussionThreadItemReviewAction"));
const Avatar_1 = __importDefault(require("../../../../components/Avatar"));
const satinizeHtml_1 = __importDefault(require("../../../../components/PreviewWysiwyg/utils/satinizeHtml"));
const mdRenderer_1 = __importDefault(require("../../../../components/PreviewWysiwyg/utils/mdRenderer"));
const DiscoverTableRow = ({ config, item, allowedActions: { canModerate, canAccessReports, canReviewReports }, onClick, }) => {
    const { reports } = item;
    const { formatDate } = (0, react_intl_1.useIntl)();
    const openReports = reports?.filter((_) => !_.resolved);
    const hasReports = !(0, lodash_1.isEmpty)(openReports);
    const reviewFlowEnabled = canAccessReports && hasReports && !(item.blocked || item.blockedThread);
    const handleClick = () => onClick();
    const renderStatus = (props) => {
        const status = (0, utils_1.resolveCommentStatus)({ ...props, reviewFlowEnabled });
        const color = (0, utils_1.resolveCommentStatusColor)(status);
        return (react_1.default.createElement(StatusBadge_1.default, { backgroundColor: `${color}100`, textColor: `${color}700`, color: color }, (0, utils_1.getMessage)({
            id: `page.common.item.status.${status}`,
            props: {
                count: openReports.length,
            },
        }, status)));
    };
    const renderEntryUrl = (entry) => entry ? `/content-manager/collectionType/${entry.uid}/${entry.id}` : null;
    const renderDetailsUrl = (entry) => (0, utils_1.getUrl)(`discover/${entry.id}`);
    const gotApprovalFlow = !(0, lodash_1.isNil)(item.approvalStatus);
    const needsApproval = gotApprovalFlow && item.approvalStatus === "PENDING";
    let actionItemsCount = 1;
    if (reviewFlowEnabled || needsApproval) {
        actionItemsCount = 2;
    }
    const { author, isAdminComment, id, content, threadOf, related, createdAt, updatedAt } = item;
    const sanitizedContent = (0, react_1.useMemo)(() => (0, satinizeHtml_1.default)(mdRenderer_1.default.render(content || ''), {
        allowedTags: [],
        allowedAttributes: {}
    }), [content]);
    return (react_1.default.createElement(Table_1.Tr, { key: id },
        react_1.default.createElement(Table_1.Td, null,
            react_1.default.createElement(Typography_1.Typography, { textColor: "neutral800", fontWeight: "bold" },
                "#",
                id)),
        react_1.default.createElement(Table_1.Td, null,
            react_1.default.createElement(Stack_1.Stack, { size: 2, horizontal: true },
                author && (react_1.default.createElement(Avatar_1.default, { avatar: author.avatar, name: author.name, isAdminComment: isAdminComment })),
                react_1.default.createElement(Typography_1.Typography, { textColor: "neutral800", variant: "pi" }, author?.name || (0, utils_1.getMessage)('compontents.author.unknown')))),
        react_1.default.createElement(Table_1.Td, { style: { maxWidth: "30vw" } },
            react_1.default.createElement(Typography_1.Typography, { textColor: "neutral800", ellipsis: true }, sanitizedContent)),
        react_1.default.createElement(Table_1.Td, null, threadOf?.id ? (react_1.default.createElement(Link_1.Link, { to: renderDetailsUrl(threadOf) }, (0, utils_1.getMessage)({
            id: "page.discover.table.cell.thread",
            props: { id: threadOf.id },
        }, "#" + threadOf.id))) : ("-")),
        react_1.default.createElement(Table_1.Td, { style: { maxWidth: "15vw" } }, related ? (react_1.default.createElement(styles_1.TableLink, { to: renderEntryUrl(related) }, (0, renderEntryTitle_1.default)(related, config))) : ("-")),
        react_1.default.createElement(Table_1.Td, null,
            react_1.default.createElement(Typography_1.Typography, { textColor: "neutral800" }, formatDate(updatedAt || createdAt, {
                dateStyle: "long",
                timeStyle: "short",
            }))),
        react_1.default.createElement(Table_1.Td, null,
            react_1.default.createElement(Typography_1.Typography, { textColor: "neutral800" }, renderStatus(item))),
        react_1.default.createElement(Table_1.Td, null,
            react_1.default.createElement(Flex_1.Flex, { direction: "column", alignItems: "flex-end" },
                react_1.default.createElement(styles_2.IconButtonGroupStyled, { isSingle: !(reviewFlowEnabled || (canModerate && needsApproval)) },
                    canModerate && needsApproval && (react_1.default.createElement(DiscussionThreadItemApprovalFlowActions_1.default, { id: id, allowedActions: { canModerate } })),
                    react_1.default.createElement(DiscussionThreadItemReviewAction_1.default, { item: item, queryToInvalidate: "get-data", allowedActions: {
                            canModerate,
                            canAccessReports,
                            canReviewReports,
                        } }),
                    react_1.default.createElement(IconButton_1.IconButton, { onClick: handleClick, label: (0, utils_1.getMessage)("page.discover.table.action.display"), icon: icons_1.eye }))))));
};
DiscoverTableRow.propTypes = {
    config: prop_types_1.default.object.isRequired,
    item: prop_types_1.default.object.isRequired,
    allowedActions: prop_types_1.default.shape({
        canModerate: prop_types_1.default.bool,
        canAccessReports: prop_types_1.default.bool,
        canReviewReports: prop_types_1.default.bool,
    }),
    onClick: prop_types_1.default.func.isRequired,
};
exports.default = DiscoverTableRow;
//# sourceMappingURL=index.js.map