"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapDispatchToProps = void 0;
const react_1 = __importStar(require("react"));
const react_redux_1 = require("react-redux");
const redux_1 = require("redux");
const react_fast_compare_1 = __importDefault(require("react-fast-compare"));
const react_query_1 = require("react-query");
const react_router_dom_1 = require("react-router-dom");
const lodash_1 = require("lodash");
const Box_1 = require("@strapi/design-system/Box");
const Layout_1 = require("@strapi/design-system/Layout");
const Table_1 = require("@strapi/design-system/Table");
const Typography_1 = require("@strapi/design-system/Typography");
const VisuallyHidden_1 = require("@strapi/design-system/VisuallyHidden");
const LiveRegions_1 = require("@strapi/design-system/LiveRegions");
const helper_plugin_1 = require("@strapi/helper-plugin");
const getMessage_1 = __importDefault(require("../../utils/getMessage"));
const api_1 = require("./utils/api");
const permissions_1 = __importDefault(require("../../permissions"));
const getUrl_1 = __importDefault(require("../../utils/getUrl"));
const Nav_1 = __importDefault(require("../../components/Nav"));
const TablePagination_1 = __importDefault(require("../../components/TablePagination"));
const filtersSchema_1 = __importDefault(require("./utils/filtersSchema"));
const TableFilters_1 = __importDefault(require("../../components/TableFilters"));
const selectors_1 = __importDefault(require("../App/reducer/selectors"));
const DiscoverTableRow_1 = __importDefault(require("./components/DiscoverTableRow"));
const NoAccessPage_1 = __importDefault(require("../NoAccessPage"));
const COL_COUNT = 8;
const Discover = ({ config }) => {
    (0, helper_plugin_1.useFocusWhenNavigate)();
    const { push } = (0, react_router_dom_1.useHistory)();
    const { notifyStatus } = (0, LiveRegions_1.useNotifyAT)();
    const { trackUsage } = (0, helper_plugin_1.useTracking)();
    const trackUsageRef = (0, react_1.useRef)(trackUsage);
    const toggleNotification = (0, helper_plugin_1.useNotification)();
    const [{ query: queryParams }] = (0, helper_plugin_1.useQueryParams)();
    const _q = queryParams?._q || '';
    const viewPermissions = (0, react_1.useMemo)(() => ({
        access: permissions_1.default.access,
        moderate: permissions_1.default.moderate,
        accessReports: permissions_1.default.reports,
        reviewReports: permissions_1.default.reportsReview,
    }), []);
    const { isLoading: isLoadingForPermissions, allowedActions: { canAccess, canModerate, canAccessReports, canReviewReports, }, } = (0, helper_plugin_1.useRBAC)(viewPermissions);
    const { isLoading: isLoadingForData, data: { result, pagination = {} }, isFetching, } = (0, react_query_1.useQuery)(['get-data', queryParams, canAccess], () => (0, api_1.fetchData)(queryParams, toggleNotification), {
        initialData: {},
    });
    const handleClickDisplay = (id) => {
        push((0, getUrl_1.default)(`discover/${id}`));
    };
    const isLoading = isLoadingForData || isFetching;
    const { total } = pagination;
    const emptyLayout = {
        comments: {
            id: (0, getMessage_1.default)('page.discover.table.empty'),
            defaultMessage: "You don't have any comments yet.",
        },
        search: {
            id: (0, getMessage_1.default)('page.discover.table.empty.search'),
            defaultMessage: 'No comments match the search.',
        },
    };
    const emptyContent = _q ? 'search' : 'comments';
    return canAccess ? (react_1.default.createElement(Box_1.Box, { background: "neutral100" },
        react_1.default.createElement(Layout_1.Layout, null, isLoading || isLoadingForPermissions ? (react_1.default.createElement(helper_plugin_1.LoadingIndicatorPage, null)) : (react_1.default.createElement(Layout_1.Layout, { sideNav: react_1.default.createElement(Nav_1.default, { visible: true }) },
            react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement(Layout_1.HeaderLayout, { title: (0, getMessage_1.default)("page.discover.header"), subtitle: `${total} ${(0, getMessage_1.default)("page.discover.header.count")}`, as: "h2" }),
                react_1.default.createElement(Layout_1.ActionLayout, { startActions: react_1.default.createElement(react_1.default.Fragment, null,
                        react_1.default.createElement(helper_plugin_1.SearchURLQuery, { label: (0, getMessage_1.default)("search.label", "Search", false) }),
                        react_1.default.createElement(TableFilters_1.default, { displayedFilters: filtersSchema_1.default })) }),
                react_1.default.createElement(Layout_1.ContentLayout, null, !(0, lodash_1.isEmpty)(result) ? (react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement(Table_1.Table, { colCount: COL_COUNT, rowCount: result.length },
                        react_1.default.createElement(Table_1.Thead, null,
                            react_1.default.createElement(Table_1.Tr, null,
                                react_1.default.createElement(Table_1.Th, null,
                                    react_1.default.createElement(Typography_1.Typography, { variant: "sigma" }, (0, getMessage_1.default)("page.discover.table.header.id"))),
                                react_1.default.createElement(Table_1.Th, null,
                                    react_1.default.createElement(Typography_1.Typography, { variant: "sigma" }, (0, getMessage_1.default)("page.discover.table.header.author"))),
                                react_1.default.createElement(Table_1.Th, null,
                                    react_1.default.createElement(Typography_1.Typography, { variant: "sigma" }, (0, getMessage_1.default)("page.discover.table.header.message"))),
                                react_1.default.createElement(Table_1.Th, null,
                                    react_1.default.createElement(Typography_1.Typography, { variant: "sigma" }, (0, getMessage_1.default)("page.discover.table.header.thread"))),
                                react_1.default.createElement(Table_1.Th, null,
                                    react_1.default.createElement(Typography_1.Typography, { variant: "sigma" }, (0, getMessage_1.default)("page.discover.table.header.entry"))),
                                react_1.default.createElement(Table_1.Th, null,
                                    react_1.default.createElement(Typography_1.Typography, { variant: "sigma" }, (0, getMessage_1.default)("page.discover.table.header.lastUpdate"))),
                                react_1.default.createElement(Table_1.Th, null,
                                    react_1.default.createElement(Typography_1.Typography, { variant: "sigma" }, (0, getMessage_1.default)("page.discover.table.header.status"))),
                                react_1.default.createElement(Table_1.Th, null,
                                    react_1.default.createElement(VisuallyHidden_1.VisuallyHidden, null, (0, getMessage_1.default)("page.discover.table.header.actions"))))),
                        react_1.default.createElement(Table_1.Tbody, null, result.map((entry) => (react_1.default.createElement(DiscoverTableRow_1.default, { key: `comment-${entry.id}`, config: config, item: entry, allowedActions: {
                                canModerate,
                                canAccessReports,
                                canReviewReports,
                            }, onClick: () => handleClickDisplay(entry.id) }))))),
                    react_1.default.createElement(TablePagination_1.default, { pagination: { pageCount: pagination?.pageCount || 1 } }))) : (react_1.default.createElement(helper_plugin_1.EmptyStateLayout, { content: emptyLayout[emptyContent] }))))))))) :
        react_1.default.createElement(NoAccessPage_1.default, null);
};
const mapStateToProps = (0, selectors_1.default)();
function mapDispatchToProps(dispatch) {
    return (0, redux_1.bindActionCreators)({}, dispatch);
}
exports.mapDispatchToProps = mapDispatchToProps;
const withConnect = (0, react_redux_1.connect)(mapStateToProps, mapDispatchToProps);
exports.default = (0, redux_1.compose)(withConnect)((0, react_1.memo)(Discover, react_fast_compare_1.default));
//# sourceMappingURL=index.js.map