"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const BaseCheckbox_1 = require("@strapi/design-system/BaseCheckbox");
const Button_1 = require("@strapi/design-system/Button");
const Table_1 = require("@strapi/design-system/Table");
const Typography_1 = require("@strapi/design-system/Typography");
;
const icons_1 = require("../../../../components/icons");
const react_1 = __importStar(require("react"));
const react_intl_1 = require("react-intl");
const CommentReviewModal_1 = __importDefault(require("../../../../components/CommentReviewModal"));
const StatusBadge_1 = __importDefault(require("../../../../components/StatusBadge"));
const utils_1 = require("../../../../utils");
const ReportsActions_1 = __importDefault(require("../../../../components/ReportsActions"));
const cellMaxWidth = { maxWidth: "30vw" };
const ReportsTableRow = ({ allowedActions, config, handleItemSelectionChange, isChecked, item, mutation, onClick, onSelectionChange, reports, selectedReports, updateReports, }) => {
    const { reports: reportedReports, } = item;
    const [modalVisible, setModalVisible] = (0, react_1.useState)(false);
    const { formatDate } = (0, react_intl_1.useIntl)();
    const openReports = reportedReports?.filter((_) => !_.resolved);
    const handleOpenModal = (0, react_1.useCallback)(() => {
        setModalVisible(true);
    }, [setModalVisible]);
    const handleCloseModal = (0, react_1.useCallback)(() => {
        setModalVisible(false);
    }, [setModalVisible]);
    const renderStatus = (props) => {
        const status = (0, utils_1.resolveReportStatus)(props);
        const color = (0, utils_1.resolveReportStatusColor)(status);
        return (react_1.default.createElement(StatusBadge_1.default, { backgroundColor: `${color}100`, textColor: `${color}700`, color: color }, (0, utils_1.getMessage)({
            id: `page.common.item.status.${status}`,
            props: {
                count: openReports.length,
            },
        }, status)));
    };
    return (react_1.default.createElement(Table_1.Tr, { key: item.id },
        react_1.default.createElement(Table_1.Td, null,
            react_1.default.createElement(BaseCheckbox_1.BaseCheckbox, { "aria-label": (0, utils_1.getMessage)("page.details.panel.discussion.warnings.reports.dialog.select"), value: isChecked(item.id), onValueChange: (value) => handleItemSelectionChange(item.id, value) })),
        react_1.default.createElement(Table_1.Td, null,
            react_1.default.createElement(Typography_1.Typography, { textColor: "neutral800", fontWeight: "bold" },
                "#",
                item.id)),
        react_1.default.createElement(Table_1.Td, null,
            react_1.default.createElement(Typography_1.Typography, { textColor: "neutral800", variant: "pi" }, item.reason || (0, utils_1.getMessage)("compontents.reason.unknown"))),
        react_1.default.createElement(Table_1.Td, { style: cellMaxWidth },
            react_1.default.createElement(Typography_1.Typography, { textColor: "neutral800", ellipsis: true }, item.content || (0, utils_1.getMessage)("compontents.content.unknown"))),
        react_1.default.createElement(Table_1.Td, { style: cellMaxWidth },
            react_1.default.createElement(Typography_1.Typography, { textColor: "neutral800", ellipsis: true }, renderStatus(item))),
        react_1.default.createElement(Table_1.Td, null,
            react_1.default.createElement(Typography_1.Typography, { textColor: "neutral800" }, formatDate(item.updatedAt || item.createdAt, {
                dateStyle: "long",
                timeStyle: "short",
            }))),
        react_1.default.createElement(Table_1.Td, null,
            react_1.default.createElement(Button_1.Button, { variant: "tertiary", startIcon: icons_1.eye, onClick: handleOpenModal }, (0, utils_1.getMessage)({
                id: "page.discover.table.cell.thread",
                props: { id: item.related.id },
            }, `#${item.related.id}`)),
            react_1.default.createElement(CommentReviewModal_1.default, { isVisible: modalVisible, onClose: handleCloseModal, item: item })),
        react_1.default.createElement(Table_1.Td, null,
            react_1.default.createElement(ReportsActions_1.default, { item: item, allowedActions: allowedActions, mutation: mutation, reports: reports, updateReports: updateReports, onSelectionChange: onSelectionChange, selectedReports: selectedReports }))));
};
exports.default = ReportsTableRow;
//# sourceMappingURL=index.js.map