"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fetchReportsData = void 0;
const qs_1 = require("qs");
const utils_1 = require("../../../utils");
const fetchReportsData = async (queryParams, toggleNotification) => {
    try {
        const { data } = await utils_1.axiosInstance.get((0, utils_1.getApiURL)(`moderate/reports${queryParams ? `?${(0, qs_1.stringify)(queryParams, { encode: false })}` : ""}`));
        return data;
    }
    catch (err) {
        (0, utils_1.handleAPIError)(err, toggleNotification);
    }
};
exports.fetchReportsData = fetchReportsData;
//# sourceMappingURL=api.js.map