"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.restartStrapi = exports.fetchRoles = exports.fetchAllContentTypes = exports.restoreConfig = exports.updateConfig = exports.fetchConfig = void 0;
const utils_1 = require("../../../utils");
const fetchConfig = async (toggleNotification) => {
    try {
        const { data } = await utils_1.axiosInstance.get((0, utils_1.getApiURL)(`settings/config`));
        return data;
    }
    catch (err) {
        (0, utils_1.handleAPIError)(err, toggleNotification, "page.settings.notification.fetch.error");
    }
};
exports.fetchConfig = fetchConfig;
const updateConfig = async (body, toggleNotification) => {
    try {
        const { data } = await utils_1.axiosInstance.put((0, utils_1.getApiURL)(`settings/config`), body);
        return data;
    }
    catch (err) {
        (0, utils_1.handleAPIError)(err, toggleNotification);
    }
};
exports.updateConfig = updateConfig;
const restoreConfig = async (toggleNotification) => {
    try {
        const { data } = await utils_1.axiosInstance.delete((0, utils_1.getApiURL)(`settings/config`));
        return data;
    }
    catch (err) {
        (0, utils_1.handleAPIError)(err, toggleNotification);
    }
};
exports.restoreConfig = restoreConfig;
const fetchAllContentTypes = async (toggleNotification) => {
    try {
        const { data } = await utils_1.axiosInstance.get(`/content-type-builder/content-types`);
        return data?.data;
    }
    catch (err) {
        (0, utils_1.handleAPIError)(err, toggleNotification);
    }
};
exports.fetchAllContentTypes = fetchAllContentTypes;
const fetchRoles = async (toggleNotification) => {
    try {
        const { data } = await utils_1.axiosInstance.get(`/admin/roles`);
        return data;
    }
    catch (err) {
        (0, utils_1.handleAPIError)(err, toggleNotification);
    }
};
exports.fetchRoles = fetchRoles;
const restartStrapi = async (toggleNotification) => {
    try {
        const { data } = await utils_1.axiosInstance.get((0, utils_1.getApiURL)(`settings/restart`));
        return data;
    }
    catch (err) {
        (0, utils_1.handleAPIError)(err, toggleNotification);
    }
};
exports.restartStrapi = restartStrapi;
//# sourceMappingURL=api.js.map