"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const axios_1 = __importDefault(require("axios"));
const helper_plugin_1 = require("@strapi/helper-plugin");
const instance = axios_1.default.create({
    baseURL: process.env.STRAPI_ADMIN_BACKEND_URL,
});
instance.interceptors.request.use(async (config) => {
    config.headers = {
        Authorization: `Bearer ${helper_plugin_1.auth.getToken()}`,
        Accept: "application/json",
        "Content-Type": "application/json",
    };
    return config;
}, (error) => {
    Promise.reject(error);
});
instance.interceptors.response.use((response) => response, (error) => {
    if (error.response?.status === 401) {
        helper_plugin_1.auth.clearAppStorage();
        window.location.reload();
    }
    throw error;
});
exports.default = instance;
//# sourceMappingURL=axiosInstance.js.map