"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_intl_1 = require("react-intl");
const pluginId_1 = require("../pluginId");
const getMessage = (input, defaultMessage = "", inPluginScope = true) => {
    const { formatMessage } = (0, react_intl_1.useIntl)();
    let formattedId = "";
    if (typeof input === 'string') {
        formattedId = input;
    }
    else {
        formattedId = input?.id.toString() || formattedId;
    }
    return formatMessage({
        id: `${inPluginScope ? pluginId_1.pluginId : "app.components"}.${formattedId}`,
        defaultMessage,
    }, typeof input === 'string' ? undefined : input?.props);
};
exports.default = getMessage;
//# sourceMappingURL=getMessage.js.map