"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const constants_1 = require("./constants");
const resolveCommentStatus = ({ removed, blocked, blockedThread, approvalStatus, reviewFlowEnabled, }) => {
    const gotApprovalFlow = !(0, lodash_1.isNil)(approvalStatus);
    if (removed) {
        return constants_1.COMMENT_STATUS.REMOVED;
    }
    if (blocked || blockedThread) {
        return constants_1.COMMENT_STATUS.BLOCKED;
    }
    if (reviewFlowEnabled) {
        return constants_1.COMMENT_STATUS.TO_REVIEW;
    }
    if (gotApprovalFlow) {
        const status = approvalStatus.toUpperCase();
        if (Object.keys(constants_1.COMMENT_STATUS).includes(status)) {
            return status;
        }
        return constants_1.COMMENT_STATUS.UNKNOWN;
    }
    return constants_1.COMMENT_STATUS.OPEN;
};
exports.default = resolveCommentStatus;
//# sourceMappingURL=resolveCommentStatus.js.map