"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("./constants");
const resolveCommentStatusColor = (status) => {
    if (Object.keys(constants_1.COMMENT_STATUS).includes(status)) {
        switch (status) {
            case constants_1.COMMENT_STATUS.REMOVED:
                return "secondary";
            case constants_1.COMMENT_STATUS.TO_REVIEW:
            case constants_1.COMMENT_STATUS.REJECTED:
                return "warning";
            case constants_1.COMMENT_STATUS.BLOCKED:
                return "danger";
            case constants_1.COMMENT_STATUS.OPEN:
            case constants_1.COMMENT_STATUS.APPROVED:
                return "success";
        }
    }
    return "secondary";
};
exports.default = resolveCommentStatusColor;
//# sourceMappingURL=resolveCommentStatusColor.js.map