"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const constants_1 = require("./constants");
const resolveReportStatus = ({ resolved, related: { blocked, blockedThread }, approvalStatus, }) => {
    const gotApprovalFlow = !(0, lodash_1.isNil)(approvalStatus);
    if (blocked || blockedThread) {
        return constants_1.REPORT_STATUS.BLOCKED;
    }
    if (resolved) {
        return constants_1.REPORT_STATUS.RESOLVED;
    }
    if (gotApprovalFlow) {
        const status = approvalStatus.toUpperCase();
        if (Object.keys(constants_1.REPORT_STATUS).includes(status)) {
            return status;
        }
        return constants_1.REPORT_STATUS.PENDING;
    }
    return constants_1.REPORT_STATUS.PENDING;
};
exports.default = resolveReportStatus;
//# sourceMappingURL=resolveReportStatus.js.map