"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const lodash_1 = require("lodash");
const permissions_1 = __importDefault(require("./../permissions"));
const functions_1 = require("./utils/functions");
module.exports = async ({ strapi }) => {
    if (strapi.plugin("graphql")) {
        const config = await (0, functions_1.getPluginService)("common").getConfig();
        const { enabledCollections } = config;
        if (!(0, lodash_1.isEmpty)(enabledCollections)) {
            await require("./graphql")({ strapi, config });
        }
    }
    if (Object.keys(strapi.plugins).indexOf("users-permissions") === -1) {
        throw new Error("In order to make the comments plugin work the users-permissions plugin is required");
    }
    const actions = [
        {
            section: "plugins",
            displayName: "Comments: Read",
            uid: permissions_1.default.comments.read,
            pluginName: "comments",
        },
        {
            section: "plugins",
            displayName: "Comments: Moderate",
            uid: permissions_1.default.comments.moderate,
            pluginName: "comments",
        },
        {
            section: "plugins",
            displayName: "Reports: Read",
            uid: permissions_1.default.reports.read,
            pluginName: "comments",
        },
        {
            section: "plugins",
            displayName: "Reports: Moderate",
            uid: permissions_1.default.reports.action,
            pluginName: "comments",
        },
        {
            section: "plugins",
            displayName: "Settings: Read",
            uid: permissions_1.default.settings.read,
            pluginName: "comments",
        },
        {
            section: "plugins",
            displayName: "Settings: Change",
            uid: permissions_1.default.settings.change,
            pluginName: "comments",
        },
    ];
    await strapi.admin.services.permission.actionProvider.registerMany(actions);
};
//# sourceMappingURL=bootstrap.js.map