"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.throwError = exports.parseParams = void 0;
const error_1 = __importDefault(require("../../utils/error"));
const parseParams = (params) => Object.keys(params).reduce((prev, curr) => {
    const value = params[curr];
    const parsedValue = Number(value);
    return {
        ...prev,
        [curr]: isNaN(parsedValue) ? value : parsedValue,
    };
}, {});
exports.parseParams = parseParams;
const throwError = (ctx, e) => {
    if (e instanceof error_1.default) {
        return ctx.throw(e.status, JSON.stringify(e));
    }
    return e;
};
exports.throwError = throwError;
//# sourceMappingURL=functions.js.map