"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const types_1 = __importDefault(require("./types"));
const queries_1 = __importDefault(require("./queries"));
const mutations_1 = __importDefault(require("./mutations"));
const resolvers_config_1 = __importDefault(require("./resolvers-config"));
const functions_1 = require("../services/utils/functions");
module.exports = async ({ strapi, config }) => {
    const extensionService = strapi.plugin("graphql").service("extension");
    extensionService.shadowCRUD((0, functions_1.getModelUid)("comment")).disableQueries();
    extensionService.shadowCRUD((0, functions_1.getModelUid)("comment")).disableMutations();
    extensionService.shadowCRUD((0, functions_1.getModelUid)("comment-report")).disableQueries();
    extensionService.shadowCRUD((0, functions_1.getModelUid)("comment-report")).disableMutations();
    extensionService.use(({ strapi, nexus }) => {
        const types = (0, types_1.default)({ strapi, nexus, config });
        const queries = (0, queries_1.default)({ strapi, nexus, config });
        const mutations = (0, mutations_1.default)({ strapi, nexus, config });
        const resolversConfig = (0, resolvers_config_1.default)({ strapi, config });
        return {
            types: [types, queries, mutations],
            resolversConfig,
        };
    });
};
//# sourceMappingURL=index.js.map