"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const createComment_1 = __importDefault(require("./createComment"));
const updateComment_1 = __importDefault(require("./updateComment"));
const removeComment_1 = __importDefault(require("./removeComment"));
const createAbuseReport_1 = __importDefault(require("./createAbuseReport"));
module.exports = (context) => {
    const mutations = {
        createComment: createComment_1.default,
        updateComment: updateComment_1.default,
        removeComment: removeComment_1.default,
        createAbuseReport: createAbuseReport_1.default,
    };
    return context.nexus.extendType({
        type: "Mutation",
        definition(t) {
            for (const [name, configFactory] of Object.entries(mutations)) {
                const config = configFactory(context);
                t.field(name, config);
            }
        },
    });
};
//# sourceMappingURL=index.js.map