"use strict";
const functions_1 = require("../../utils/functions");
module.exports = ({ nexus }) => {
    const { nonNull } = nexus;
    return {
        type: nonNull("CommentSingle"),
        args: {
            input: nonNull("UpdateComment"),
        },
        async resolve(_, args, ctx) {
            const { input } = args;
            const { state: { user = undefined } = {} } = ctx;
            const { id, relation, ...body } = input;
            try {
                return await (0, functions_1.getPluginService)("client").update(id, relation, body, user);
            }
            catch (e) {
                throw new Error(e);
            }
        },
    };
};
//# sourceMappingURL=updateComment.js.map