"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const lodash_1 = require("lodash");
const comment_1 = __importDefault(require("../../../content-types/comment"));
const parsers_1 = require("../../controllers/utils/parsers");
const functions_1 = require("../../utils/functions");
module.exports = ({ strapi, nexus }) => {
    const { nonNull, stringArg } = nexus;
    const { service: getService } = strapi.plugin("graphql");
    const { args } = getService("internals");
    return {
        type: "ResponseFindAll",
        args: {
            relation: nonNull(stringArg()),
            filters: (0, functions_1.getPluginService)("gql").buildContentTypeFilters(comment_1.default),
            pagination: args.PaginationArg,
            sort: args.SortArg,
        },
        async resolve(obj, args) {
            const { relation, filters, sort, pagination } = args;
            return await (0, functions_1.getPluginService)("common").findAllFlat((0, parsers_1.flatInput)({
                relation,
                query: (0, functions_1.getPluginService)("gql").graphQLFiltersToStrapiQuery(filters, comment_1.default),
                sort,
                pagination: pagination
                    ? {
                        ...pagination,
                        withCount: !(0, lodash_1.isEmpty)(pagination),
                    }
                    : undefined,
            }), undefined);
        },
    };
};
//# sourceMappingURL=findAllFlat.js.map