"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const comment_1 = __importDefault(require("../../../content-types/comment"));
const parsers_1 = require("../../controllers/utils/parsers");
const functions_1 = require("../../utils/functions");
module.exports = ({ strapi, nexus }) => {
    const { nonNull, list, stringArg } = nexus;
    const { service: getService } = strapi.plugin("graphql");
    const { args } = getService("internals");
    const { naming: { getFiltersInputTypeName }, } = getService("utils");
    return {
        type: nonNull(list("CommentNested")),
        args: {
            relation: nonNull(stringArg()),
            sort: args.SortArg,
            filters: getFiltersInputTypeName(comment_1.default),
        },
        async resolve(obj, args) {
            const { relation, filters, sort } = args;
            return await (0, functions_1.getPluginService)("common").findAllInHierarchy({
                ...(0, parsers_1.flatInput)({
                    relation,
                    query: (0, functions_1.getPluginService)("gql").graphQLFiltersToStrapiQuery(filters, comment_1.default),
                    sort,
                }),
                dropBlockedThreads: true,
            });
        },
    };
};
//# sourceMappingURL=findAllInHierarchy.js.map