"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const findAllFlat_1 = __importDefault(require("./findAllFlat"));
const findAllInHierarchy_1 = __importDefault(require("./findAllInHierarchy"));
const findAllPerAuthor_1 = __importDefault(require("./findAllPerAuthor"));
module.exports = (context) => {
    const queries = {
        findAllFlat: findAllFlat_1.default,
        findAllInHierarchy: findAllInHierarchy_1.default,
        findAllPerAuthor: findAllPerAuthor_1.default,
    };
    return context.nexus.extendType({
        type: "Query",
        definition(t) {
            for (const [name, configFactory] of Object.entries(queries)) {
                const config = configFactory(context);
                t.field(name, config);
            }
        },
    });
};
//# sourceMappingURL=index.js.map