"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class PluginError extends Error {
    status;
    payload;
    constructor(status, message, payload = undefined) {
        super();
        this.name = "Strapi:Plugin:Comments";
        this.status = status || 500;
        this.message = message || "Internal error";
        this.payload = payload;
        Object.setPrototypeOf(this, PluginError.prototype);
    }
    toString(e = this) {
        return `${e.name} - ${e.message}`;
    }
    toJSON() {
        if (this.payload) {
            return {
                ...this.payload,
                name: this.name,
                message: this.message,
            };
        }
        return this;
    }
}
exports.default = PluginError;
//# sourceMappingURL=error.js.map