"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertNotEmpty = exports.assertParamsPresent = exports.parseParams = exports.getPluginService = void 0;
const error_1 = __importDefault(require("./error"));
const getPluginService = (name) => strapi.plugin("comments").service(name);
exports.getPluginService = getPluginService;
const parseParams = (params) => Object.keys(params).reduce((prev, curr) => {
    const value = params[curr];
    const parsedValue = Number(value);
    return {
        ...prev,
        [curr]: isNaN(parsedValue) ? value : parsedValue,
    };
}, {});
exports.parseParams = parseParams;
const assertParamsPresent = (params, keys) => {
    const missingParams = params instanceof Object
        ? keys.filter((key) => !params.hasOwnProperty(key))
        : keys;
    if (missingParams.length === 0) {
        return;
    }
    throw new error_1.default(400, `Expected params missing: ${missingParams.join(", ")}`);
};
exports.assertParamsPresent = assertParamsPresent;
const assertNotEmpty = (value, customError) => {
    if (value) {
        return;
    }
    throw (customError ?? new error_1.default(400, "Non-empty value expected, empty given"));
};
exports.assertNotEmpty = assertNotEmpty;
//# sourceMappingURL=functions.js.map