import { CommentsPluginConfig } from "./types";
declare const _default: () => {
    contentTypes: {
        comment: {
            schema: {
                info: {
                    tableName: string;
                    singularName: string;
                    pluralName: string;
                    displayName: string;
                    description: string;
                    kind: string;
                };
                options: {
                    draftAndPublish: boolean;
                };
                pluginOptions: {
                    "content-manager": {
                        visible: boolean;
                    };
                    "content-type-builder": {
                        visible: boolean;
                    };
                };
                attributes: {
                    content: {
                        type: string;
                        configurable: boolean;
                        required: boolean;
                    };
                    blocked: {
                        type: string;
                        default: boolean;
                        configurable: boolean;
                    };
                    blockedThread: {
                        type: string;
                        default: boolean;
                        configurable: boolean;
                    };
                    blockReason: {
                        type: string;
                        configurable: boolean;
                    };
                    authorUser: {
                        type: string;
                        relation: string;
                        target: string;
                        configurable: boolean;
                    };
                    authorId: {
                        type: string;
                        configurable: boolean;
                    };
                    authorName: {
                        type: string;
                        configurable: boolean;
                    };
                    authorEmail: {
                        type: string;
                        configurable: boolean;
                    };
                    authorAvatar: {
                        type: string;
                        configurable: boolean;
                    };
                    isAdminComment: {
                        type: string;
                        configurable: boolean;
                    };
                    removed: {
                        type: string;
                        configurable: boolean;
                    };
                    approvalStatus: {
                        type: string;
                        configurable: boolean;
                    };
                    related: {
                        type: string;
                        configurable: boolean;
                    };
                    reports: {
                        type: string;
                        relation: string;
                        target: string;
                        mappedBy: string;
                        configurable: boolean;
                    };
                    threadOf: {
                        type: string;
                        relation: string;
                        target: string;
                        configurable: boolean;
                    };
                };
            };
        };
        "comment-report": {
            schema: {
                info: {
                    tableName: string;
                    singularName: string;
                    pluralName: string;
                    displayName: string;
                    description: string;
                    kind: string;
                };
                options: {
                    draftAndPublish: boolean;
                };
                pluginOptions: {
                    "content-manager": {
                        visible: boolean;
                    };
                    "content-type-builder": {
                        visible: boolean;
                    };
                };
                attributes: {
                    content: {
                        type: string;
                        configurable: boolean;
                    };
                    reason: {
                        type: string;
                        enum: string[];
                        default: string;
                        configurable: boolean;
                        required: boolean;
                    };
                    resolved: {
                        type: string;
                        default: boolean;
                        configurable: boolean;
                    };
                    related: {
                        type: string;
                        relation: string;
                        target: string;
                        inversedBy: string;
                        configurable: boolean;
                    };
                };
            };
        };
    };
    config: {
        default: () => {
            enabledCollections: string[];
            moderatorRoles: string[];
            approvalFlow: string[];
            blockedAuthorProps: string[];
            entryLabel: PluginConfigEntryLabels;
            reportReasons: PluginConfigReportReasons;
            badWords?: boolean | undefined;
            client?: import("./types").PluginConfigClientService | undefined;
            gql?: import("./types").PluginConfigGraphQL | undefined;
        };
        validator: (config: CommentsPluginConfig) => void;
    };
    register: (context: import("strapi-typed").StrapiContext) => void;
    bootstrap: ({ strapi }: import("strapi-typed").StrapiContext) => Promise<void>;
    destroy: () => void;
    controllers: {
        [key: string]: Object | Function;
    };
    routes: {
        [key: string]: {
            type: string;
            routes: import("strapi-typed").StrapiRoute[];
        };
    };
    services: {
        admin: ({ strapi }: import("strapi-typed").StrapiContext) => import("./types").IServiceAdmin;
        client: ({ strapi }: import("strapi-typed").StrapiContext) => import("./types").IServiceClient;
        common: ({ strapi }: import("strapi-typed").StrapiContext) => import("./types").IServiceCommon;
        gql: ({ strapi }: import("strapi-typed").StrapiContext) => import("./types").IServiceGraphQL;
    };
    policies: {};
    middlewares: {};
};
export = _default;
//# sourceMappingURL=strapi-server.d.ts.map